﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Imports System.IO
Imports System.Drawing.Drawing2D
Imports System.Drawing

Public Class Logo : Inherits Panel
    Private bmp As Bitmap
    Private g As Graphics
    Public Sub New()
        bmp = New Bitmap(24, 82)
        g = Graphics.FromImage(bmp)
    End Sub
    Protected Overrides Sub OnPaint(e As PaintEventArgs)
        Dim szLines() As String
        Dim arrPixel(5) As String
        Dim i As Integer
        g.Clear(Color.Transparent)
        Dim lineA As String = String.Empty
        Using reader As TextReader = New StringReader(My.Resources.Resource1.logo)
            lineA += reader.ReadLine
        End Using

        szLines = lineA.Split(";")
        For i = 0 To szLines.Length() - 2
            arrPixel = szLines(i).Split(",")
            If (CInt(arrPixel(2)) <> 255 And CInt(arrPixel(3)) <> 255 And CInt(arrPixel(4)) <> 255) Then
                bmp.SetPixel(CInt(arrPixel(0)), CInt(arrPixel(1)), Color.FromArgb(CInt(arrPixel(2)), CInt(arrPixel(3)), CInt(arrPixel(4))))
            End If
        Next
        Me.CreateGraphics.DrawImage(bmp, New Point(5, Height - 120))
    End Sub
End Class
