﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Public Class PopupMenu

    Private clrBack As Color
    Private clrForColor As Color
    Private panMenu As Panel
    Private par As Panel
    Private propertyGrid As PPropertyGrid
    Private objDzoDraw As DZODraw
    Public isVisible As Boolean = False


    Public Sub New(_designer As DZODraw, _clrBack As Color, _clrForeColor As Color)
        clrBack = _clrBack
        clrForColor = _clrForeColor
        objDzoDraw = _designer
    End Sub

    Public Function DestroyPopupMenu() As ptObject
        isVisible = False
        Dim o As ptObject = propertyGrid.getPtObj()
        If (panMenu IsNot Nothing) Then
            propertyGrid = Nothing
            par.Controls.Remove(panMenu)
            panMenu = Nothing
        End If
        Return o
    End Function

    Public Function GetPopupMenuStyleLines(ByRef pt As ptObject, p As Panel, x As Integer, y As Integer, objSetting As ISettings) As Panel
        panMenu = New Panel
        panMenu.BorderStyle = BorderStyle.FixedSingle
        panMenu.Width = 200
        panMenu.BackColor = clrBack
        panMenu.ForeColor = clrForColor
        panMenu.Height = objSetting.getCountProperties() * 40 + 100
        propertyGrid = New PPropertyGrid(objDzoDraw, panMenu, objSetting, "")
        propertyGrid.setPtObject(pt)
        propertyGrid.Create(p)
        panMenu.Visible = True
        panMenu.Location = New Point(x, y)
        propertyGrid.Width = panMenu.Width
        propertyGrid.Height = panMenu.Height
        propertyGrid.Left = 0
        propertyGrid.Top = 0
        propertyGrid.Select()
        par = p
        isVisible = True
        Return panMenu
    End Function



End Class
