﻿Imports System.ComponentModel
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Drawing.Drawing2D
Imports System.Drawing


Public Class Principal
    Public dict As Dictionary
    Private logo As Logo
    Private btnMenu(5) As Button
    Private panMenu(5) As Panel
    Private propertyMenu(3) As PPropertyGrid
    Private propertyGridButtonSave(3) As Panel
    Private propertyGridButtonCancel(3) As Panel
    Private toolTipText As New Label
    Private menuSel As Integer = 0
    Private fileNotFound As Boolean
    Const PLEFT As Integer = 40
    Public Shared HEIGHT_PROP As Integer
    Public Shared WIDTH_PROP As Integer = 250
    Public Shared xmlAppSetting As String = "AppSetting.xml"
    Public Shared xmlDesignSetting As String = "DesignSetting.xml"
    Private bActivated As Boolean = False
    Public arrCaption(2) As String
    Public arrpCaption(2) As String
    Public _appSettings As New AppSettings()
    Public _designSettings As New DesignSettings()
    Public _objSettings As New ObjSetting()
    Public objSetting As Settings
    Const HEIGHT_BUTTON = 30
    Public strMenu As String
    Public caption As String
    Public strTabs As String
    Public tabsPanel(5) As Panel
    Public tabsButton(5) As CTab
    Public arrButton(25) As CDButton
    Public NUMGRAPHICS As Integer = 14
    Public dmenu As Menu
    Dim btn As CDButton
    Public imageBitmap As Bitmap
    Public nMode As Integer
    Public bCopy As Boolean
    Public bIncolla As Boolean
    Public Const CLEAR = 0
    Public Const LINE = 1
    Public Const LINEARROW = 2
    Public Const LINEARROWSE = 3
    Public Const PEN = 4
    Public Const RECTANGLE = 5
    Public Const L_SEC = 6
    Public Const T_SECT = 7
    Public Const TRIANGLE = 8
    Public Const CUBO = 9
    Public Const ELLIPSE = 10
    Public Const CURVE = 11
    Public Const BULLONE = 12
    Public Const TREND = 13
    Public Const FILL = 14
    Public Const SELECTION = 15
    Public Const COPY = 16
    Public Const PASTE = 17
    Public Const DELETE = 18
    Public Const IIMAGE = 19
    Public Const LABEL = 20
    Public Const GRID = 21
    Public Const ZOOM_M = 22
    Public Const ZOOM_P = 23
    Public Const EXIT_APP = 24
    Public Const OK = 25
    Public Const CANCEL = 26
    Public Const NONE = -1
    Public objDesigner As Designer
    Public libraryImage As Library
    Public hhelp As Help
    Public aasistenza As Assistenza
    Private libraryLed As Panel
    Private librarySwitch As Panel
    Private libraryIcons As Library
    Private panelToolBarDesign As Panel
    Private bkColorSel As Color = Color.Red
    Private foreColorSel As Color = Color.Black
    Private cursorFill As New Cursor("bucket.cur")
    Public bGrid As Boolean = False
    Public anag As Anagrafica
    Public calcolo As Calcolo
    Public geo As Geolocal
    Public stmPdf As pdfDesign.StampaPdf
    Public HscrollX As Integer
    Public VscrollV As Integer
    Public Const SOLID_STYLE = "______________________"
    Public Const DASH_STYLE = "----------------------"
    Public Const DOT_STYLE = "......................"
    Public Const DASDOT_STYLE = "-.-.-.-.-.-.-.-.-.-.-."
    Public nResizeLeft As Boolean = False
    Public nResizeRight As Boolean = False
    Public nResizeUp As Boolean = False
    Public nResizeDown As Boolean = False
    Public colorResizeCursor As Color = Color.Black
    Public colorMenuCursor As Color = Color.Black


    Private Sub Principal_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        dict = New Dictionary("EN")
        CreateControls()

    End Sub

    Public Sub CreateControls()
        bActivated = False
        For Each ctrl In Controls
            If Mid(ctrl.name, 1, 3) = "Tab" Then
                Controls.Remove(ctrl)
            End If

        Next
        For Each ctrl In Properties.Controls
            Properties.Controls.Remove(ctrl)
        Next
        For Each ctrl In PanelToolBar.Controls
            PanelToolBar.Controls.Remove(ctrl)
        Next
        Dim i As Integer

        strMenu = dict.getMsg(0) ' Opzioni Menu| Opzioni disegno | Grafici | Iconi | Guida | Assistenza
        caption = dict.getMsg(1)
        strTabs = dict.getMsg(2)

        _appSettings = New AppSettings
        _appSettings.Load()
        _designSettings = New DesignSettings
        _designSettings.Load()
        objDesigner = New Designer(Me)
        objSetting = New Settings(_appSettings, xmlAppSetting, _designSettings, xmlDesignSetting)
        Properties.BackColor = ToolBar.BackColor
        arrCaption = strTabs.Split("|")
        For i = 0 To arrCaption.Length - 1
            ' Buttons9
            tabsButton(i) = New CTab()
            tabsButton(i).setProperties(arrCaption(i), _designSettings.DesignBackColor,
            _appSettings.MenuForeColor, _appSettings.ApplicationFont, Len(arrCaption(i)) * 10, 80)
            tabsButton(i).Name = "Tab" & CStr(i)
            tabsButton(i).Left = Me.PanelToolBar.Left
            If (i > 0) Then
                tabsButton(i).Left = tabsButton(i - 1).Left + tabsButton(i - 1).Width - 2
            End If
            tabsButton(i).Top = Me.PanelToolBar.Bottom - tabsButton(i).Height
            tabsButton(i).Dock = DockStyle.None
            tabsButton(i).Visible = True
            tabsButton(i).Cursor = Cursors.Hand
            tabsButton(i).BringToFront()
            AddHandler tabsButton(i).Click, AddressOf tabsButton_click
            Me.PanelToolBar.Controls.Add(tabsButton(i))
                If (i > 0) Then

                    tabsPanel(i) = New Panel
                    tabsPanel(i).Name = "TabPan" & CStr(i)
                    tabsPanel(i).Left = Design.Left
                    tabsPanel(i).Top = Design.Top
                    tabsPanel(i).Width = Design.Width
                    tabsPanel(i).Height = Design.Height
                    tabsPanel(i).Dock = Design.Dock
                    tabsButton(i).SetSelected(False)
                    tabsPanel(i).BackColor = Color.FromArgb(224 + i, 224 + i, 224 + i)
                    tabsButton(i).updateTab(tabsPanel(i).BackColor, _appSettings.MenuBackColor, _appSettings.ApplicationFont)
                    tabsPanel(i).Visible = False
                    If i = 4 Then
                        anag = New Anagrafica(tabsPanel(i))
                        anag.CreateControls()
                    End If
                    If i = 2 Then
                        calcolo = New Calcolo(tabsPanel(i))
                        calcolo.CreateControls()
                    End If

                    If i = 3 Then
                        geo = New Geolocal(tabsPanel(i))
                        geo.CreateControls()
                    End If
                    If i = 1 Then
                        stmPdf = New pdfDesign.StampaPdf(tabsPanel(i))
                        stmPdf.CreatePDFControls()
                    End If

                    Me.Controls.Add(tabsPanel(i))
                End If
            Next
        tabsButton(0).SetSelected(True)
        panelToolBarDesign = New Panel
        panelToolBarDesign.Left = PanelToolBar.Left
        panelToolBarDesign.Width = PanelToolBar.Width
        panelToolBarDesign.Height = 50
        arrpCaption = strMenu.Split("|")
        Dim p As Integer = 0
        For i = 0 To btnMenu.Length() - 1
            btnMenu(i) = New Button
            btnMenu(i).Text = arrpCaption(i)
            btnMenu(i).Width = Properties.Width - 80
            btnMenu(i).Left = 25
            btnMenu(i).Height = 30
            btnMenu(i).Top = 10 + i * (btnMenu(i).Height) + p
            p = p + 10
            btnMenu(i).BackColor = _appSettings.MenuBackColor
            btnMenu(i).ForeColor = _appSettings.MenuForeColor
            btnMenu(i).FlatStyle = FlatStyle.Flat
            btnMenu(i).Cursor = Cursors.Hand
            btnMenu(i).Visible = True
            Me.Properties.Controls.Add(btnMenu(i))
            AddHandler btnMenu(i).Click, AddressOf btnMenu_click
            AddHandler btnMenu(i).MouseHover, AddressOf HandleDynamicButtonMouseHover
            AddHandler btnMenu(i).MouseLeave, AddressOf HandleDynamicButtonMouseLeave
            panMenu(i) = New Panel
            panMenu(i).Width = btnMenu(i).Width
            panMenu(i).Top = btnMenu(i).Bottom + 2
            panMenu(i).Left = btnMenu(i).Left
            panMenu(i).Height = 600
            panMenu(i).Visible = False
            panMenu(i).BackColor = Color.White
            panMenu(i).TabIndex = i
            If (i = 0) Then
                propertyMenu(i) = New PPropertyGrid(objDesigner, panMenu(i), _appSettings, xmlAppSetting)
                propertyMenu(i).Create(Properties)
            End If
            If (i = 1) Then
                propertyMenu(i) = New PPropertyGrid(objDesigner, panMenu(i), _designSettings, xmlDesignSetting)
                propertyMenu(i).Create(Properties)
            End If
            If (i > 1) Then
                Properties.Controls.Add(panMenu(i))
            End If
            btnMenu(i).Invalidate()
        Next
        Properties.Invalidate()
        arrCaption = caption.Split("|")
        For i = 0 To arrCaption.Length - 1
            ' Buttons
            arrButton(i) = New CDButton With {
                .Top = 10,
                .Name = "BT" & CStr(i),
                .Text = arrCaption(i),
                .TabIndex = i,
                .Width = Me.Width / (arrButton.Length + 3),
                .Height = HEIGHT_BUTTON,
                .Font = New Font(_appSettings.ApplicationFont.Name, _appSettings.ApplicationFont.Size)
            }
            arrButton(i).setProperties(arrCaption(i), _appSettings.MenuBackColor, _appSettings.MenuForeColor, 32, 32)
            arrButton(i).Invalidate()

            If (i = 0) Then
                arrButton(i).Left = 10
            Else
                arrButton(i).Left = arrButton(i - 1).Left + arrButton(i - 1).Width + 10
            End If
            AddHandler arrButton(i).Click, AddressOf HandleDynamicButtonClick

            panelToolBarDesign.Controls.Add(arrButton(i))
        Next
        Me.PanelToolBar.Controls.Add(panelToolBarDesign)

        Design.AutoScroll = True
        Design.AutoScrollMinSize = New System.Drawing.Size(Design.Size.Width * 2, Design.Size.Height * 2)
        dmenu = New Menu(_appSettings.MenuBackColor, _appSettings.MenuForeColor, objDesigner)
        dmenu.CreateMenu(PanelMenu, 0, 0)
        ToolBar.Height = HEIGHT_BUTTON * 5
        ReOrder()
        draw()
        bActivated = True
        WindowState = FormWindowState.Maximized
        libraryImage = New Library()
        libraryImage.Load(Me, panMenu(2), FileSystem.CurDir & "\Buttons\grafici")
        libraryIcons = New Library()
        libraryImage.Load(Me, panMenu(3), FileSystem.CurDir & "\Buttons\icons")
        UpdateColors()

        hhelp = New Help
        hhelp.Load(Me, panMenu(4))

        aasistenza = New Assistenza
        aasistenza.Load(Me, panMenu(5))

        logo = New Logo
        logo.Left = 0
        logo.Dock = DockStyle.Right
        logo.Top = 20
        logo.Width = 37
        logo.Height = 124
        logo.Visible = True
        logo.BackColor = _appSettings.ApplicationBackColor
        logo.Invalidate()
        Properties.Controls.Add(logo)


    End Sub
    Private Sub ReOrder()

        If bActivated Then
            For i = 0 To arrCaption.Length - 1
                ' Buttons
                arrButton(i).Top = 50
                arrButton(i).Width = Me.Width / (arrButton.Length + 3)
                arrButton(i).Height = HEIGHT_BUTTON
                arrButton(i).Left = IIf(i = 0, 10, arrButton(i - 1).Left + arrButton(i - 1).Width + 10)
            Next
            ToolBar.Height = HEIGHT_BUTTON * 5
        End If
    End Sub

    Private Sub btnMenu_click(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        For Each ctrl In Me.Properties.Controls
            If (ctrl.name <> "tooltip") Then
                ctrl.foreColor = _appSettings.MenuForeColor
            End If
            If (TypeOf ctrl Is Button And btn.Text = ctrl.Text) Then
                Dim p As Integer = 0
                For i = 0 To btnMenu.Length - 1
                    btnMenu(i).Height = 30
                    btnMenu(i).Top = 10 + i * (btnMenu(i).Height) + p
                    p = p + 10
                    If (btnMenu(i).Text = btn.Text) Then
                        menuSel = i
                    End If
                Next
                If (panMenu(menuSel).Visible) Then
                    panMenu(menuSel).Visible = False
                    Exit Sub
                End If
                For i = 0 To btnMenu.Length - 1
                    panMenu(i).Visible = False
                Next
                panMenu(menuSel).Visible = True
                panMenu(menuSel).Top = btn.Bottom + 2
                For i = menuSel + 1 To btnMenu.Length - 1
                    If (i = menuSel + 1) Then
                        btnMenu(i).Top = panMenu(menuSel).Bottom + 1
                    Else
                        btnMenu(i).Top = btnMenu(i - 1).Bottom + 10
                    End If
                Next
            End If
        Next

    End Sub

    Public Function IsInResize() As Boolean
        Return (nResizeLeft Or nResizeRight Or nResizeDown Or nResizeUp)
    End Function

    Public Sub ResetResize()
        Cursor = Cursors.Default
        nResizeLeft = False
        nResizeRight = False
        nResizeDown = False
        nResizeUp = False
    End Sub

    Private Sub HandleDynamicButtonMouseHover(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        If btn.ForeColor = foreColorSel And btn.BackColor = bkColorSel Then Exit Sub
        btn.BackColor = _appSettings.MenuForeColor
        btn.ForeColor = _appSettings.MenuBackColor
    End Sub
    Private Sub HandleDynamicButtonMouseLeave(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        If btn.ForeColor = foreColorSel And btn.BackColor = bkColorSel Then Exit Sub
        btn.BackColor = _appSettings.MenuBackColor
        btn.ForeColor = _appSettings.MenuForeColor
    End Sub


    Private Sub tabsButton_click(sender As Object, e As EventArgs)
        Dim i As Integer
        Dim btn As CTab = DirectCast(sender, CTab)
        Design.Visible = False
        tabsButton(0).SetSelected(False)
        For i = 1 To tabsPanel.Length - 2
            tabsPanel(i).Visible = False
            tabsButton(i).SetSelected(False)
            tabsButton(i).updateTab(Design.BackColor, _appSettings.MenuBackColor, _appSettings.ApplicationFont)
        Next
        btn.SetSelected(True)
        panelToolBarDesign.Visible = False
        If (CInt(Mid(btn.Name, 4)) = 0) Then
            Design.Visible = True
            panelToolBarDesign.Visible = True
            tabsButton(btn.TabIndex).updateTab(Design.BackColor, _appSettings.MenuBackColor,
                           _appSettings.ApplicationFont)
            Design.BringToFront()
        Else
            tabsPanel(btn.TabIndex).Visible = True
            tabsButton(btn.TabIndex).updateTab(Design.BackColor, _appSettings.MenuBackColor,
                                       _appSettings.ApplicationFont)
        End If
        If (btn.TabIndex = 1) Then
            If objDesigner.lstDrawOject.Count > 0 Then
                objDesigner.deselectAll()
                objDesigner.Draw()
                stmPdf.acrobat.Navigate("about:blank")
                stmPdf.Load(objDesigner.getBitmap())
            End If
        End If
        If (btn.TabIndex = 5) Then
            If objDesigner.lstSelDrawOject.Count > 0 Then
            End If
        End If
    End Sub
    Public Sub setButtonSelectiobSelected()
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                If (ctrl.TabIndex = SELECTION) Then
                    ctrl.setSelected(True)
                Else
                    ctrl.setSelected(False)
                End If
            End If
        Next
    End Sub
    Private Sub HandleDynamicButtonClick(sender As Object, e As EventArgs)
        'On Error Resume Next
        Cursor = Cursors.Arrow
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                ctrl.setSelected(False)
            End If
        Next
        Dim btn As CDButton = DirectCast(sender, CDButton)
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                ctrl.setSelected(False)
                If (btn.TabIndex = ctrl.TabIndex) Then
                    If ctrl.TabIndex = ZOOM_M Then
                        objDesigner.ZooomM()
                        Exit Sub
                    ElseIf ctrl.TabIndex = ZOOM_P Then
                        objDesigner.ZooomP()
                        Exit Sub
                    End If
                End If
            End If
        Next
        If TypeOf btn Is CDButton Then
            objDesigner.FinalizeCurveDraw()
            btn.SetSelected(True)
            If btn.TabIndex <> COPY And btn.TabIndex <> DELETE Then
                objDesigner.deselectAll()
                ResetResize()
            End If
            nMode = btn.TabIndex
            Select Case btn.TabIndex
                Case CLEAR
                    btn.SetSelected(False)
                    objDesigner.Update()
                    Exit Sub
                Case DELETE
                    btn.SetSelected(False)
                    objDesigner.Draw()
                    Exit Sub
                Case COPY
                    objDesigner.CopySelectedObject()
                    Exit Sub
                Case PASTE
                    objDesigner.PasteCopiedObject()
                    btn.SetSelected(False)
                    Exit Sub
                Case IIMAGE
                    Dim fd As OpenFileDialog = New OpenFileDialog()
                    Dim strFileName As String
                    fd.Title = "Open File Dialog"
                    fd.InitialDirectory = "c:"
                    fd.Filter = "Jpeg files (*.jpg)|*.jpg|All files (*.*)|*.*"
                    fd.FilterIndex = 2
                    fd.RestoreDirectory = True
                    If fd.ShowDialog() = DialogResult.OK Then
                        strFileName = fd.FileName
                        imageBitmap = New Bitmap(strFileName)
                        objDesigner.Update()
                    Else
                        nMode = NONE
                    End If
                    btn.SetSelected(False)
                    Exit Sub
                Case GRID
                    bGrid = Not bGrid
                    If Not bGrid Then
                        btn.SetSelected(False)
                    End If
                    objDesigner.Draw()
                Case CURVE
                    objDesigner.lstCurveDrawOject.Clear()
                    objDesigner.bFinalizeDrawCurve = False
                Case EXIT_APP
                    Close()
                    End
            End Select
        End If

    End Sub

    Public Sub UpdateColors()
        On Error Resume Next
        If Not bActivated Or Me.WindowState = FormWindowState.Minimized Then Exit Sub
        Dim i As Integer
        If Design.BackColor <> _designSettings.DesignBackColor Or
            Design.ForeColor <> _designSettings.DesignForeColor Or
             tabsButton(2)._backColor <> _appSettings.MenuBackColor Then
            Design.BackColor = _designSettings.DesignBackColor
            Design.ForeColor = _designSettings.DesignForeColor
            For i = 0 To tabsButton.Length - 2
                tabsButton(i).updateTab(Design.BackColor, _appSettings.MenuBackColor,
                                        _appSettings.ApplicationFont)
            Next
            tabsButton(1).updateTab(Color.FromArgb(224, 224, 224), _appSettings.MenuBackColor, _appSettings.ApplicationFont)
            tabsButton(2)._backColor = _appSettings.MenuBackColor
        End If
        If (PanelToolBar.BackColor <> _appSettings.ApplicationBackColor Or
            PanelToolBar.ForeColor <> _appSettings.ApplicationForeColor Or
            Properties.BackColor <> _appSettings.ApplicationBackColor Or
            Properties.ForeColor <> _appSettings.ApplicationForeColor) Then
            PanelToolBar.BackColor = _appSettings.ApplicationBackColor
            PanelToolBar.ForeColor = _appSettings.ApplicationForeColor
            Properties.BackColor = _appSettings.ApplicationBackColor
            Properties.ForeColor = _appSettings.ApplicationForeColor
        End If

        If Not arrButton(0) Is Nothing Then
            If arrButton(0).Font.Name <> _appSettings.ApplicationFont.Name Or
            arrButton(0).Font.Size <> _appSettings.ApplicationFont.Size Then
                ReOrder()
                draw()
            End If
            If arrButton(0).BackColor <> _appSettings.MenuBackColor Or
                arrButton(0).ForeColor <> _appSettings.MenuForeColor Then
                For Each ctrl In Me.PanelToolBar.Controls
                    If TypeOf ctrl Is CDButton Then
                        ctrl.updateIconsColor(_appSettings.MenuBackColor, _appSettings.MenuForeColor)
                    End If

                Next
            End If
        End If
        dmenu.UpdateColors(_appSettings.MenuBackColor, _appSettings.MenuForeColor)
        If nMode <> LABEL Then
            objDesigner.editText.Visible = False
        Else
            If (objDesigner.editText.Visible) Then
                If objDesigner.editText.ForeColor <> _designSettings.DesignForeColor Or
                    objDesigner.editText.BackColor <> _designSettings.DesignBackColor Or
                    BackColor <> objDesigner.editText.BackColor Then
                    objDesigner.editText.ForeColor = _designSettings.DesignForeColor
                    objDesigner.editText.BackColor = _designSettings.DesignBackColor
                    BackColor = objDesigner.editText.BackColor
                End If
                draw()
                Exit Sub
            End If
        End If
    End Sub

    Public Sub draw()
        If Not bActivated Then Exit Sub
        '"Clear|Line|Rectangle|Eclipse|Fill|Selection|Copia|Incolla|Cancella|Image|Resize|Label|Esci"
        For Each ctrl In Me.ToolBar.Controls
            ctrl.SetSelected(False)
        Next
        Select Case nMode
            Case CLEAR
            Case LINE
            Case LINEARROW
            Case LINEARROWSE
            Case RECTANGLE
            Case ELLIPSE
            Case SELECTION
            Case DELETE
            Case LABEL
                arrButton(nMode).SetSelected(True)
        End Select
    End Sub





    Private Sub Design_MouseDown(sender As Object, e As MouseEventArgs) Handles Design.MouseDown
        If objDesigner Is Nothing Then Exit Sub
        dmenu.MenuLeave()
        objDesigner.MouseDown(sender, e)
        If (Not objDesigner.editText.Visible) Then
            Design.Select()
        End If
    End Sub

    Private Sub Design_MouseMove(sender As Object, e As MouseEventArgs) Handles Design.MouseMove
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.MouseMove(sender, e)
    End Sub

    Private Sub Design_MouseUp(sender As Object, e As MouseEventArgs) Handles Design.MouseUp
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.MouseUp(sender, e)

    End Sub
    Private Sub Design_KeyDown(sender As Object, e As KeyEventArgs) Handles Design.KeyDown
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.KeyDown(sender, e)
        objDesigner.Draw()
    End Sub

    Private Sub Design_KeyUp(sender As Object, e As KeyEventArgs) Handles Design.KeyUp
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.KeyUp(sender, e)
    End Sub


    Private Sub Properties_MouseEnter(sender As System.Object, e As System.EventArgs) Handles Properties.MouseEnter
        Properties.Cursor = Cursors.Arrow
    End Sub

    Private Sub PanelToolBar_MouseEnter(sender As System.Object, e As System.EventArgs) Handles PanelToolBar.MouseEnter
        PanelToolBar.Cursor = Cursors.Arrow
    End Sub


    Private Sub Design_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles Design.Paint
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.Draw()
    End Sub


    Private Sub Design_Leave(sender As System.Object, e As System.EventArgs) Handles Design.Leave
        If objDesigner Is Nothing Then Exit Sub
        If objDesigner.editText.Visible Then
            objDesigner.editText.Visible = False
            nMode = NONE
        End If
    End Sub


    Private Sub Design_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles Design.Scroll
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.Draw()

    End Sub

    Private Sub Design_MouseDoubleClick(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles Design.MouseDoubleClick
        If objDesigner Is Nothing Then Exit Sub
        objDesigner.deselectAll()
        objDesigner.Draw()
    End Sub

    Private Sub Design_PreviewKeyDown(sender As System.Object, e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles Design.PreviewKeyDown

    End Sub

    Private Sub Properties_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles Properties.Paint

    End Sub

    Private Sub Properties_MouseHover(sender As System.Object, e As System.EventArgs) Handles Properties.MouseHover

    End Sub

    Private Sub GlControl1_Load(sender As System.Object, e As System.EventArgs)

    End Sub

    Private Sub PanelMenu_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles PanelMenu.Paint

    End Sub

    Private Sub PanelToolBar_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles PanelToolBar.Paint

    End Sub

    Private Sub ToolBar_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles ToolBar.Paint

    End Sub

    Private Sub Principal_Resize(sender As System.Object, e As System.EventArgs) Handles MyBase.Resize
        If logo Is Nothing Then Exit Sub
        logo.Invalidate()
    End Sub

    Private Sub Design_MouseLeave(sender As System.Object, e As System.EventArgs) Handles Design.MouseLeave
    End Sub

    Private Sub Design_MouseEnter(sender As System.Object, e As System.EventArgs) Handles Design.MouseEnter

    End Sub

    Private Sub Principal_Activated(sender As System.Object, e As System.EventArgs) Handles MyBase.Activated
        _designSettings.setPrincipal(Me)
    End Sub


    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs)

    End Sub
End Class






