﻿Public Class Menu
    Public pPanel As Panel
    Private mLabel(3) As Label
    Private mmLabel(3) As Label
    Private mPanel(3) As Panel
    Private captionMenu As String
    Private itemsMenu As String
    Const HEIGHT_ITEM As Integer = 30
    Const WIDTH_ITEM As Integer = 100
    Private backColor As Color
    Private foreColor As Color
    Private mCloseWin As PictureBox
    Private tPanel As Panel
    Private designer As Designer
    Public Sub New(bkColor As Color, frColor As Color, _designer As Designer)
        backColor = bkColor
        foreColor = frColor
        designer = _designer
    End Sub

    Public Sub CreateMenu(pPanel As Panel, left As Integer, top As Integer)
        captionMenu = Principal.dict.getMsg(3)
        itemsMenu = Principal.dict.getMsg(4)

        pPanel.Left = left
        pPanel.Top = top
        pPanel.Height = HEIGHT_ITEM
        Const wLabel As Integer = WIDTH_ITEM
        Dim sMenu(4) As String
        tPanel = pPanel
        sMenu = captionMenu.Split("|")
        For i = 0 To mLabel.Length - 2
            mLabel(i) = New Label()
            mLabel(i).Text = sMenu(i)
            mLabel(i).Height = HEIGHT_ITEM
            mLabel(i).Left = 20 + i * mLabel(i).Width
            mLabel(i).TextAlign = ContentAlignment.MiddleCenter
            mLabel(i).Width = wLabel
            mLabel(i).Top = 0 ' (HEIGHT_ITEM - mLabel(i).Height) / 2
            mLabel(i).Visible = True
            mLabel(i).ForeColor = foreColor
            mLabel(i).BackColor = backColor
            mLabel(i).Cursor = Cursors.Hand
            AddHandler mLabel(i).MouseHover, AddressOf mLabelHover
            AddHandler mLabel(i).MouseLeave, AddressOf mLabelLeave
            AddHandler mLabel(i).Click, AddressOf mLabelClick
            pPanel.Controls.Add(mLabel(i))
        Next
        pPanel.BackColor = backColor
        Dim sPanelText(3) As String
        sPanelText = itemsMenu.Split("&")
        Dim sLabelText(3) As String
        For i = 0 To mPanel.Length - 2
            mPanel(i) = New Panel()
            mPanel(i).Width = WIDTH_ITEM * 2
            mPanel(i).BackColor = backColor
            mPanel(i).Left = 20 + i * mLabel(i).Width
            mPanel(i).Top = pPanel.Bottom
            mPanel(i).Cursor = Cursors.Arrow
            sLabelText = sPanelText(i).Split("|")
            For j = 0 To mLabel.Length - 2
                If sLabelText(j).Length > 0 Then
                    mmLabel(j) = New Label()
                    mmLabel(j).Text = "    " & sLabelText(j)
                    mmLabel(j).Top = 10 + (j * mmLabel(j).Height * 2)
                    mmLabel(j).TextAlign = ContentAlignment.MiddleLeft
                    mmLabel(j).Width = mPanel(i).Width
                    mmLabel(j).Left = 0
                    mmLabel(j).Height = HEIGHT_ITEM
                    mmLabel(j).Visible = True
                    mmLabel(j).ForeColor = foreColor
                    mmLabel(j).BackColor = backColor
                    mmLabel(j).Cursor = Cursors.Hand
                    AddHandler mmLabel(j).MouseHover, AddressOf mLabelHover
                    AddHandler mmLabel(j).MouseLeave, AddressOf mLabelLeave
                    AddHandler mmLabel(j).Click, AddressOf mLabelClick
                    mPanel(i).Controls.Add(mmLabel(j))
                    mPanel(i).Height = mPanel(i).Height + mmLabel(j).Height
                    mPanel(i).Visible = False
                End If
            Next
            Dim f As Form = (pPanel.Parent).Parent
            f.Controls.Add(mPanel(i))
        Next
    End Sub

    Private Sub mLabelLeave(sender As Object, e As EventArgs)
        Dim lbl As Label = DirectCast(sender, Label)
        lbl.BackColor = backColor
        lbl.ForeColor = foreColor
    End Sub
    Public Sub MenuLeave()
        Dim i As Integer
        For i = 0 To 2
            mPanel(i).Visible = False
        Next
    End Sub
    Private Sub mLabelHover(sender As Object, e As EventArgs)
        Dim lbl As Label = DirectCast(sender, Label)
        lbl.BackColor = foreColor
        lbl.ForeColor = backColor

        If Mid(lbl.Text, 1, 4) = "File" Then
            MenuLeave()
            mPanel(0).BringToFront()
            mPanel(0).Visible = True
        End If
        If Mid(lbl.Text, 1, 4) = "View" Then
            MenuLeave()
            mPanel(1).BringToFront()
            mPanel(1).Visible = True
        End If
        If Mid(lbl.Text, 1, 2) = "Op" Then
            MenuLeave()
            mPanel(2).BringToFront()
            mPanel(2).Visible = True
        End If
    End Sub
    Private Sub mLabelClick(sender As Object, e As EventArgs)
        Dim lbl As Label = DirectCast(sender, Label)
        Dim szItem As String
        szItem = Trim(lbl.Text)
        MenuLeave()
        If Mid(szItem, 1, 4) = "Open" Then
            designer.LoadProject()
        End If
        If Mid(szItem, 1, 3) = "New" Then
            designer.Clear()
        End If

        If Mid(szItem, 1, 3) = "Save" Then
            designer.SalvaProgetto()
        End If
        If szItem.Trim() = "Italian" Or szItem.Trim() = "Italiano" Then
            Principal.dict = Nothing
            Principal.dict = New Dictionary("IT")
            Principal.CreateControls()
        End If
        If szItem.Trim() = "Inglese" Or szItem.Trim() = "English" Then
            Principal.dict = Nothing
            Principal.dict = New Dictionary("EN")
            Principal.CreateControls()
        End If

    End Sub

    Public Sub UpdateColors(bkColor As Color, frColor As Color)
        If backColor <> bkColor Or foreColor <> frColor Then
            backColor = bkColor
            foreColor = frColor
            For i = 0 To mLabel.Length - 2
                mLabel(i).ForeColor = foreColor
                mLabel(i).BackColor = backColor
            Next
            tPanel.BackColor = backColor
            For i = 0 To mmLabel.Length - 2
                mmLabel(i).ForeColor = foreColor
                mmLabel(i).BackColor = backColor
            Next
            For i = 0 To mPanel.Length - 2
                mPanel(i).BackColor = backColor
            Next
        End If
    End Sub

    
    Public Function getBottomMenu() As Integer
        getBottomMenu = mLabel(0).Bottom
    End Function

End Class
