﻿Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Drawing.Drawing2D
Imports System.Drawing
Imports System.Math
Imports System.Drawing.Imaging

Public Structure ptObject
    Public name As String
    Public X1 As Point
    Public X2 As Point
    Public XORIG1 As Point
    Public XORIG2 As Point
    Public penLine As Pen
    Public draw As Integer
    Public bitmap As Bitmap
    Public text As String
    Public directionText As String
    Public lstPtCurve As ArrayList
    Public font As Font
    Public rotation As Integer
    Public penSize As Single
    Public penStyle As String
    Public FillColor As Color
    Public FillColor2 As Color
    Public ForeColor As Color
    Public bringToFront As Boolean
    Public brightness As Double
    Public contrast As Double
    Public gamma As Double
    Public orderDesign As Integer
    Public brushBitmap As String
    Public dCube As Integer
End Structure



Public Class Designer
    Private bm As Bitmap
    Dim gmatrix As New Matrix
    Dim gmatrixIma As New Matrix
    Dim bMouseDown As Boolean
    Dim mousePoint As Point
    Public bInResize As Boolean = False
    Dim penSel As New Pen(Principal.colorMenuCursor)
    Dim penSelMenu As New Pen(Principal.colorMenuCursor)
    Public ptObjectC As ptObject
    Public objResize As ptObject
    Public lstDrawOject As New List(Of ptObject)
    Public lstRedoDrawOject As New List(Of ptObject)
    Public lstTempDrawOject As New ArrayList()
    Public lstSelDrawOject As New List(Of ptObject)
    Public lstCopiedSelDrawOject As New ArrayList()
    Public lstCurveDrawOject As New ArrayList()
    Dim lstSelUpdDrawOject As New ArrayList()
    Private ptSelAll As Point
    Private ptSelAllF As Point
    Private bInSelect As Boolean
    Dim oldLocation As Point
    Public editText As New TextBox
    Private source As Principal
    Private g As Graphics
    Dim ctrlKey As Boolean = False
    Private ptFill As Point
    Private cursorFill As New Cursor("bucket.cur")
    Private HscrollX As Integer = 0
    Private VscrollY As Integer = 0
    Private ANGLE_ROTATION = 180
    Private tline(2) As Double
    Const theta As Double = 3.1415 / 180
    Private diffX As Integer
    Private diffY As Integer
    Private poMenu As PopupMenu
    Public bFinalizeDrawCurve As Boolean = False
    Private cursorTurnLeft As String = "8,0, 202, 202, 202;9,0, 189, 189, 189;10,0, 167, 167, 167;11,0, 193, 193, 193;12,0, 204, 204, 204;13,0, 212, 212, 212;5,1, 205, 205, 205;6,1, 166, 166, 166;7,1, 154, 154, 154;8,1, 161, 161, 161;9,1, 156, 156, 156;10,1, 161, 161, 161;11,1, 164, 164, 164;12,1, 153, 153, 153;13,1, 163, 163, 163;14,1, 161, 161, 161;15,1, 200, 200, 200;4,2, 188, 188, 188;5,2, 161, 161, 161;6,2, 163, 163, 163;7,2, 190, 190, 190;8,2, 206, 206, 206;9,2, 223, 223, 223;10,2, 225, 225, 225;11,2, 213, 213, 213;12,2, 209, 209, 209;13,2, 190, 190, 190;14,2, 156, 156, 156;15,2, 163, 163, 163;16,2, 193, 193, 193;3,3, 167, 167, 167;4,3, 151, 151, 151;5,3, 181, 181, 181;6,3, 220, 220, 220;7,3, 246, 246, 246;8,3, 244, 244, 244;9,3, 241, 241, 241;10,3, 225, 225, 225;11,3, 240, 240, 240;12,3, 248, 248, 248;13,3, 247, 247, 247;14,3, 226, 226, 226;15,3, 184, 184, 184;16,3, 158, 158, 158;17,3, 167, 167, 167;2,4, 193, 193, 193;3,4, 158, 158, 158;4,4, 187, 187, 187;5,4, 239, 239, 239;6,4, 251, 251, 251;7,4, 211, 211, 211;8,4, 186, 186, 186;9,4, 167, 167, 167;10,4, 169, 169, 169;11,4, 160, 160, 160;12,4, 182, 182, 182;13,4, 222, 222, 222;14,4, 251, 251, 251;15,4, 228, 228, 228;16,4, 187, 187, 187;17,4, 151, 151, 151;18,4, 188, 188, 188;2,5, 163, 163, 163;3,5, 184, 184, 184;4,5, 228, 228, 228;5,5, 230, 230, 230;6,5, 190, 190, 190;7,5, 162, 162, 162;8,5, 158, 158, 158;9,5, 167, 167, 167;10,5, 180, 180, 180;11,5, 154, 154, 154;12,5, 153, 153, 153;13,5, 152, 152, 152;14,5, 182, 182, 182;15,5, 230, 230, 230;16,5, 239, 239, 239;17,5, 181, 181, 181;18,5, 161, 161, 161;1,6, 161, 161, 161;2,6, 156, 156, 156;3,6, 226, 226, 226;4,6, 251, 251, 251;5,6, 181, 181, 181;6,6, 157, 157, 157;7,6, 180, 180, 180;8,6, 217, 217, 217;9,6, 235, 235, 235;10,6, 242, 242, 242;11,6, 248, 248, 248;12,6, 208, 208, 208;13,6, 166, 166, 166;14,6, 157, 157, 157;15,6, 190, 190, 190;16,6, 251, 251, 251;17,6, 220, 220, 220;18,6, 163, 163, 163;19,6, 166, 166, 166;0,7, 212, 212, 212;1,7, 163, 163, 163;2,7, 190, 190, 190;3,7, 247, 247, 247;4,7, 222, 222, 222;5,7, 151, 151, 151;6,7, 166, 166, 166;7,7, 238, 238, 238;8,7, 254, 254, 254;13,7, 238, 238, 238;14,7, 180, 180, 180;15,7, 162, 162, 162;16,7, 211, 211, 211;17,7, 246, 246, 246;18,7, 190, 190, 190;19,7, 154, 154, 154;20,7, 221, 221, 221;0,8, 204, 204, 204;1,8, 153, 153, 153;2,8, 209, 209, 209;3,8, 248, 248, 248;4,8, 181, 181, 181;5,8, 153, 153, 153;6,8, 208, 208, 208;11,8, 214, 214, 214;12,8, 235, 235, 235;13,8, 254, 254, 254;14,8, 217, 217, 217;15,8, 158, 158, 158;16,8, 186, 186, 186;17,8, 244, 244, 244;18,8, 206, 206, 206;19,8, 161, 161, 161;20,8, 202, 202, 202;0,9, 193, 193, 193;1,9, 164, 164, 164;2,9, 213, 213, 213;3,9, 240, 240, 240;4,9, 160, 160, 160;5,9, 154, 154, 154;6,9, 248, 248, 248;11,9, 192, 192, 192;12,9, 187, 187, 187;13,9, 207, 207, 207;14,9, 211, 211, 211;15,9, 164, 164, 164;16,9, 167, 167, 167;17,9, 241, 241, 241;18,9, 223, 223, 223;19,9, 156, 156, 156;20,9, 189, 189, 189;0,10, 167, 167, 167;1,10, 161, 161, 161;2,10, 225, 225, 225;3,10, 225, 225, 225;4,10, 169, 169, 169;5,10, 180, 180, 180;6,10, 242, 242, 242;11,10, 201, 201, 201;12,10, 153, 153, 153;13,10, 160, 160, 160;14,10, 174, 174, 174;15,10, 164, 164, 164;16,10, 169, 169, 169;17,10, 225, 225, 225;18,10, 225, 225, 225;19,10, 161, 161, 161;20,10, 167, 167, 167;0,11, 189, 189, 189;1,11, 156, 156, 156;2,11, 223, 223, 223;3,11, 241, 241, 241;4,11, 167, 167, 167;5,11, 167, 167, 167;6,11, 235, 235, 235;11,11, 226, 226, 226;12,11, 158, 158, 158;13,11, 156, 156, 156;14,11, 167, 167, 167;15,11, 150, 150, 150;16,11, 159, 159, 159;17,11, 240, 240, 240;18,11, 213, 213, 213;19,11, 164, 164, 164;20,11, 193, 193, 193;0,12, 202, 202, 202;1,12, 161, 161, 161;2,12, 206, 206, 206;3,12, 244, 244, 244;4,12, 186, 186, 186;5,12, 158, 158, 158;6,12, 217, 217, 217;11,12, 244, 244, 244;12,12, 182, 182, 182;13,12, 167, 167, 167;14,12, 186, 186, 186;15,12, 152, 152, 152;16,12, 181, 181, 181;17,12, 248, 248, 248;18,12, 209, 209, 209;19,12, 151, 151, 151;20,12, 181, 181, 181;21,12, 226, 226, 226;0,13, 221, 221, 221;1,13, 154, 154, 154;2,13, 190, 190, 190;3,13, 246, 246, 246;4,13, 211, 211, 211;5,13, 162, 162, 162;6,13, 180, 180, 180;7,13, 238, 238, 238;11,13, 253, 253, 253;12,13, 224, 224, 224;13,13, 161, 161, 161;14,13, 219, 219, 219;15,13, 230, 230, 230;16,13, 234, 234, 234;17,13, 248, 248, 248;18,13, 191, 191, 191;19,13, 151, 151, 151;20,13, 157, 157, 157;21,13, 181, 181, 181;22,13, 201, 201, 201;23,13, 222, 222, 222;1,14, 166, 166, 166;2,14, 163, 163, 163;3,14, 220, 220, 220;4,14, 251, 251, 251;5,14, 190, 190, 190;6,14, 157, 157, 157;7,14, 166, 166, 166;8,14, 208, 208, 208;9,14, 248, 248, 248;10,14, 242, 242, 242;11,14, 246, 246, 246;12,14, 238, 238, 238;13,14, 176, 176, 176;14,14, 173, 173, 173;15,14, 240, 240, 240;17,14, 254, 254, 254;18,14, 207, 207, 207;19,14, 166, 166, 166;20,14, 177, 177, 177;21,14, 156, 156, 156;22,14, 153, 153, 153;23,14, 174, 174, 174;24,14, 199, 199, 199;1,15, 205, 205, 205;2,15, 161, 161, 161;3,15, 181, 181, 181;4,15, 239, 239, 239;5,15, 230, 230, 230;6,15, 182, 182, 182;7,15, 152, 152, 152;8,15, 153, 153, 153;9,15, 157, 157, 157;10,15, 180, 180, 180;11,15, 210, 210, 210;12,15, 246, 246, 246;13,15, 197, 197, 197;14,15, 150, 150, 150;15,15, 207, 207, 207;16,15, 247, 247, 247;17,15, 248, 248, 248;18,15, 235, 235, 235;19,15, 229, 229, 229;20,15, 182, 182, 182;21,15, 156, 156, 156;22,15, 150, 150, 150;23,15, 178, 178, 178;24,15, 207, 207, 207;2,16, 188, 188, 188;3,16, 151, 151, 151;4,16, 187, 187, 187;5,16, 228, 228, 228;6,16, 251, 251, 251;7,16, 222, 222, 222;8,16, 182, 182, 182;9,16, 161, 161, 161;10,16, 157, 157, 157;11,16, 172, 172, 172;12,16, 241, 241, 241;13,16, 229, 229, 229;14,16, 150, 150, 150;15,16, 176, 176, 176;16,16, 216, 216, 216;17,16, 189, 189, 189;18,16, 172, 172, 172;19,16, 157, 157, 157;20,16, 177, 177, 177;21,16, 190, 190, 190;22,16, 218, 218, 218;23,16, 238, 238, 238;3,17, 167, 167, 167;4,17, 158, 158, 158;5,17, 184, 184, 184;6,17, 226, 226, 226;7,17, 247, 247, 247;8,17, 248, 248, 248;9,17, 240, 240, 240;10,17, 182, 182, 182;11,17, 165, 165, 165;12,17, 231, 231, 231;14,17, 187, 187, 187;15,17, 151, 151, 151;16,17, 156, 156, 156;17,17, 160, 160, 160;18,17, 174, 174, 174;19,17, 208, 208, 208;4,18, 193, 193, 193;5,18, 159, 159, 159;6,18, 156, 156, 156;7,18, 190, 190, 190;8,18, 208, 208, 208;9,18, 208, 208, 208;10,18, 187, 187, 187;11,18, 155, 155, 155;12,18, 221, 221, 221;14,18, 216, 216, 216;15,18, 176, 176, 176;16,18, 193, 193, 193;17,18, 218, 218, 218;5,19, 164, 164, 164;6,19, 157, 157, 157;7,19, 159, 160, 160;8,19, 152, 152, 152;9,19, 161, 161, 161;10,19, 158, 158, 158;11,19, 153, 153, 153;12,19, 202, 202, 202;7,20, 207, 207, 207;8,20, 194, 194, 194;9,20, 186, 186, 186;10,20, 174, 174, 174;11,20, 188, 188, 188;12,20, 229, 229, 229;"
    Private cursorTurnRight As String = "11,0, 212, 212, 212;12,0, 204, 204, 204;13,0, 193, 193, 193;14,0, 167, 167, 167;15,0, 189, 189, 189;16,0, 202, 202, 202;9,1, 200, 200, 200;10,1, 161, 161, 161;11,1, 163, 163, 163;12,1, 153, 153, 153;13,1, 164, 164, 164;14,1, 161, 161, 161;15,1, 156, 156, 156;16,1, 161, 161, 161;17,1, 154, 154, 154;18,1, 166, 166, 166;19,1, 205, 205, 205;8,2, 193, 193, 193;9,2, 163, 163, 163;10,2, 156, 156, 156;11,2, 190, 190, 190;12,2, 209, 209, 209;13,2, 213, 213, 213;14,2, 225, 225, 225;15,2, 223, 223, 223;16,2, 206, 206, 206;17,2, 190, 190, 190;18,2, 163, 163, 163;19,2, 161, 161, 161;20,2, 188, 188, 188;7,3, 167, 167, 167;8,3, 158, 158, 158;9,3, 184, 184, 184;10,3, 226, 226, 226;11,3, 247, 247, 247;12,3, 248, 248, 248;13,3, 240, 240, 240;14,3, 225, 225, 225;15,3, 241, 241, 241;16,3, 244, 244, 244;17,3, 246, 246, 246;18,3, 220, 220, 220;19,3, 181, 181, 181;20,3, 151, 151, 151;21,3, 167, 167, 167;6,4, 188, 188, 188;7,4, 151, 151, 151;8,4, 187, 187, 187;9,4, 228, 228, 228;10,4, 251, 251, 251;11,4, 222, 222, 222;12,4, 182, 182, 182;13,4, 160, 160, 160;14,4, 169, 169, 169;15,4, 167, 167, 167;16,4, 186, 186, 186;17,4, 211, 211, 211;18,4, 251, 251, 251;19,4, 239, 239, 239;20,4, 187, 187, 187;21,4, 158, 158, 158;22,4, 193, 193, 193;6,5, 161, 161, 161;7,5, 181, 181, 181;8,5, 239, 239, 239;9,5, 230, 230, 230;10,5, 182, 182, 182;11,5, 152, 152, 152;12,5, 153, 153, 153;13,5, 154, 154, 154;14,5, 180, 180, 180;15,5, 167, 167, 167;16,5, 158, 158, 158;17,5, 162, 162, 162;18,5, 190, 190, 190;19,5, 230, 230, 230;20,5, 228, 228, 228;21,5, 184, 184, 184;22,5, 163, 163, 163;5,6, 166, 166, 166;6,6, 163, 163, 163;7,6, 220, 220, 220;8,6, 251, 251, 251;9,6, 190, 190, 190;10,6, 157, 157, 157;11,6, 166, 166, 166;12,6, 208, 208, 208;13,6, 248, 248, 248;14,6, 242, 242, 242;15,6, 235, 235, 235;16,6, 217, 217, 217;17,6, 180, 180, 180;18,6, 157, 157, 157;19,6, 181, 181, 181;20,6, 251, 251, 251;21,6, 226, 226, 226;22,6, 156, 156, 156;23,6, 161, 161, 161;4,7, 221, 221, 221;5,7, 154, 154, 154;6,7, 190, 190, 190;7,7, 246, 246, 246;8,7, 211, 211, 211;9,7, 162, 162, 162;10,7, 180, 180, 180;11,7, 238, 238, 238;16,7, 254, 254, 254;17,7, 238, 238, 238;18,7, 166, 166, 166;19,7, 151, 151, 151;20,7, 222, 222, 222;21,7, 247, 247, 247;22,7, 190, 190, 190;23,7, 163, 163, 163;24,7, 212, 212, 212;4,8, 202, 202, 202;5,8, 161, 161, 161;6,8, 206, 206, 206;7,8, 244, 244, 244;8,8, 186, 186, 186;9,8, 158, 158, 158;10,8, 217, 217, 217;11,8, 254, 254, 254;12,8, 235, 235, 235;13,8, 214, 214, 214;18,8, 208, 208, 208;19,8, 153, 153, 153;20,8, 181, 181, 181;21,8, 248, 248, 248;22,8, 209, 209, 209;23,8, 153, 153, 153;24,8, 204, 204, 204;4,9, 189, 189, 189;5,9, 156, 156, 156;6,9, 223, 223, 223;7,9, 241, 241, 241;8,9, 167, 167, 167;9,9, 164, 164, 164;10,9, 211, 211, 211;11,9, 207, 207, 207;12,9, 187, 187, 187;13,9, 192, 192, 192;18,9, 248, 248, 248;19,9, 154, 154, 154;20,9, 160, 160, 160;21,9, 240, 240, 240;22,9, 213, 213, 213;23,9, 164, 164, 164;24,9, 193, 193, 193;4,10, 167, 167, 167;5,10, 161, 161, 161;6,10, 225, 225, 225;7,10, 225, 225, 225;8,10, 169, 169, 169;9,10, 164, 164, 164;10,10, 174, 174, 174;11,10, 160, 160, 160;12,10, 153, 153, 153;13,10, 201, 201, 201;18,10, 242, 242, 242;19,10, 180, 180, 180;20,10, 169, 169, 169;21,10, 225, 225, 225;22,10, 225, 225, 225;23,10, 161, 161, 161;24,10, 167, 167, 167;4,11, 193, 193, 193;5,11, 164, 164, 164;6,11, 213, 213, 213;7,11, 240, 240, 240;8,11, 159, 159, 159;9,11, 150, 150, 150;10,11, 167, 167, 167;11,11, 156, 156, 156;12,11, 158, 158, 158;13,11, 226, 226, 226;18,11, 235, 235, 235;19,11, 167, 167, 167;20,11, 167, 167, 167;21,11, 241, 241, 241;22,11, 223, 223, 223;23,11, 156, 156, 156;24,11, 189, 189, 189;3,12, 226, 226, 226;4,12, 181, 181, 181;5,12, 151, 151, 151;6,12, 209, 209, 209;7,12, 248, 248, 248;8,12, 181, 181, 181;9,12, 152, 152, 152;10,12, 186, 186, 186;11,12, 167, 167, 167;12,12, 182, 182, 182;13,12, 244, 244, 244;18,12, 217, 217, 217;19,12, 158, 158, 158;20,12, 186, 186, 186;21,12, 244, 244, 244;22,12, 206, 206, 206;23,12, 161, 161, 161;24,12, 202, 202, 202;1,13, 222, 222, 222;2,13, 201, 201, 201;3,13, 181, 181, 181;4,13, 157, 157, 157;5,13, 151, 151, 151;6,13, 191, 191, 191;7,13, 248, 248, 248;8,13, 234, 234, 234;9,13, 230, 230, 230;10,13, 219, 219, 219;11,13, 161, 161, 161;12,13, 224, 224, 224;13,13, 253, 253, 253;17,13, 238, 238, 238;18,13, 180, 180, 180;19,13, 162, 162, 162;20,13, 211, 211, 211;21,13, 246, 246, 246;22,13, 190, 190, 190;23,13, 154, 154, 154;24,13, 221, 221, 221;0,14, 199, 199, 199;1,14, 174, 174, 174;2,14, 153, 153, 153;3,14, 156, 156, 156;4,14, 177, 177, 177;5,14, 166, 166, 166;6,14, 207, 207, 207;7,14, 254, 254, 254;9,14, 240, 240, 240;10,14, 173, 173, 173;11,14, 176, 176, 176;12,14, 238, 238, 238;13,14, 246, 246, 246;14,14, 242, 242, 242;15,14, 248, 248, 248;16,14, 208, 208, 208;17,14, 166, 166, 166;18,14, 157, 157, 157;19,14, 190, 190, 190;20,14, 251, 251, 251;21,14, 220, 220, 220;22,14, 163, 163, 163;23,14, 166, 166, 166;0,15, 207, 207, 207;1,15, 178, 178, 178;2,15, 150, 150, 150;3,15, 156, 156, 156;4,15, 182, 182, 182;5,15, 229, 229, 229;6,15, 235, 235, 235;7,15, 248, 248, 248;8,15, 247, 247, 247;9,15, 207, 207, 207;10,15, 150, 150, 150;11,15, 197, 197, 197;12,15, 246, 246, 246;13,15, 210, 210, 210;14,15, 180, 180, 180;15,15, 157, 157, 157;16,15, 153, 153, 153;17,15, 152, 152, 152;18,15, 182, 182, 182;19,15, 230, 230, 230;20,15, 239, 239, 239;21,15, 181, 181, 181;22,15, 161, 161, 161;23,15, 205, 205, 205;1,16, 238, 238, 238;2,16, 218, 218, 218;3,16, 190, 190, 190;4,16, 177, 177, 177;5,16, 157, 157, 157;6,16, 172, 172, 172;7,16, 189, 189, 189;8,16, 216, 216, 216;9,16, 176, 176, 176;10,16, 150, 150, 150;11,16, 229, 229, 229;12,16, 241, 241, 241;13,16, 172, 172, 172;14,16, 157, 157, 157;15,16, 161, 161, 161;16,16, 182, 182, 182;17,16, 222, 222, 222;18,16, 251, 251, 251;19,16, 228, 228, 228;20,16, 187, 187, 187;21,16, 151, 151, 151;22,16, 188, 188, 188;5,17, 208, 208, 208;6,17, 174, 174, 174;7,17, 160, 160, 160;8,17, 156, 156, 156;9,17, 151, 151, 151;10,17, 187, 187, 187;12,17, 231, 231, 231;13,17, 165, 165, 165;14,17, 182, 182, 182;15,17, 240, 240, 240;16,17, 248, 248, 248;17,17, 247, 247, 247;18,17, 226, 226, 226;19,17, 184, 184, 184;20,17, 158, 158, 158;21,17, 167, 167, 167;7,18, 218, 218, 218;8,18, 193, 193, 193;9,18, 176, 176, 176;10,18, 216, 216, 216;12,18, 221, 221, 221;13,18, 155, 155, 155;14,18, 187, 187, 187;15,18, 208, 208, 208;16,18, 208, 208, 208;17,18, 190, 190, 190;18,18, 156, 156, 156;19,18, 159, 159, 159;20,18, 193, 193, 193;12,19, 202, 202, 202;13,19, 153, 153, 153;14,19, 158, 158, 158;15,19, 161, 161, 161;16,19, 152, 152, 152;17,19, 159, 160, 160;18,19, 157, 157, 157;19,19, 164, 164, 164;12,20, 229, 229, 229;13,20, 188, 188, 188;14,20, 174, 174, 174;15,20, 186, 186, 186;16,20, 194, 194, 194;17,20, 207, 207, 207;"
    Public CurrentMouseX As Integer
    Public CurrentMouseY As Integer
    Private drawLineArrow As New Arrow



    Public Sub New(ByRef _source As Principal)
        source = _source
        source.nMode = Principal.CLEAR
        editText.Name = "label"
        editText.Width = 800
        editText.ForeColor = source._designSettings.DesignForeColor
        editText.BackColor = source._designSettings.DesignBackColor
        editText.Font = New Font(source._designSettings.DesignFont.Name, source._designSettings.DesignFont.Size)
        editText.Visible = False
        editText.BorderStyle = BorderStyle.None
        AddHandler editText.Leave, AddressOf editTextLeave
        AddHandler editText.KeyDown, AddressOf editTextKeydown
        source.Design.Controls.Add(editText)
        poMenu = New PopupMenu(Me, source._appSettings.ApplicationBackColor, source._appSettings.ApplicationForeColor)
        bm = New Bitmap(source.Design.Width * 2, source.Design.Height * 2, PixelFormat.Format32bppArgb)
    End Sub

    Private Sub Rotate(left As Boolean)
        Dim angle As Integer = 360 / 5
        Dim xc, yc, r, cx, cy As Integer
        If lstSelDrawOject.Count > 0 Then
            For Each ptSel In lstSelDrawOject
                Dim obj As ptObject = ptSel
                Select Case obj.draw
                    Case Principal.LINE
                        Dim j As Integer = 1
                        obj.rotation = IIf(left, obj.rotation + 3, obj.rotation - 3)
                        For k As Integer = 0 To tline.Length - 1
                            tline(k) = theta * (angle + j + obj.rotation)
                            j += 144
                        Next
                        r = Math.Sqrt((obj.XORIG2.X - obj.XORIG1.X) ^ 2 + (obj.XORIG2.Y - obj.XORIG1.Y) ^ 2) / 2
                        cx = obj.XORIG1.X + ((obj.XORIG2.X - obj.XORIG1.X) / 2)
                        cy = obj.XORIG1.Y + ((obj.XORIG2.Y - obj.XORIG1.Y) / 2)
                        xc = CInt(cx + Math.Cos(tline(0)))
                        yc = CInt(cy + Math.Sin(tline(0)))
                        obj.X1.X = xc + CInt(r * Math.Cos(tline(0)))
                        obj.X1.Y = yc + CInt(r * Math.Sin(tline(0)))
                        obj.X2.X = xc + CInt(r * Math.Cos(tline(1)))
                        obj.X2.Y = yc + CInt(r * Math.Sin(tline(1)))
                        For Each pt In lstDrawOject
                            If (pt.name = obj.name) Then
                                lstDrawOject.Remove(pt)
                                Exit For
                            End If
                        Next
                    Case Principal.IIMAGE
                        obj.rotation = IIf(left, obj.rotation + 3, obj.rotation - 3)
                        drawImageRot(obj)
                        For Each pt In lstDrawOject
                            If (pt.name = obj.name) Then
                                lstDrawOject.Remove(pt)
                                Exit For
                            End If
                        Next
                End Select
                lstDrawOject.Add(obj)
                lstTempDrawOject.Add(obj)
            Next
            lstSelDrawOject.Clear()
            For Each pt In lstTempDrawOject
                AddSelectionObject(pt)
            Next
            Draw()
            source.Design.Invalidate()
        End If
    End Sub
    Public Sub drawImageRot(obj As ptObject)
        On Error Resume Next
        Dim wid As Single = obj.X2.X - obj.X1.X
        Dim hgt As Single = obj.X2.Y - obj.X1.Y
        Dim corners As Point() = { _
            New Point(obj.X1.X, obj.X1.Y), _
            New Point(obj.X1.X + wid, obj.X1.Y), _
            New Point(obj.X1.X, obj.X1.Y + hgt), _
            New Point(obj.X1.X + wid, obj.X1.Y + hgt)}
        Dim cx As Single = obj.X1.X + wid / 2
        Dim cy As Single = obj.X1.Y + hgt / 2
        Dim i As Long
        For i = 0 To 3
            corners(i).X -= cx
            corners(i).Y -= cy
        Next i
        Dim theta As Single = Single.Parse(obj.rotation) * PI / 180.0
        Dim sin_theta As Single = Sin(theta)
        Dim cos_theta As Single = Cos(theta)
        Dim X As Single
        Dim Y As Single
        For i = 0 To 3
            X = corners(i).X
            Y = corners(i).Y
            corners(i).X = X * cos_theta + Y * sin_theta
            corners(i).Y = -X * sin_theta + Y * cos_theta
        Next i
        Dim xmin As Single = corners(0).X
        Dim ymin As Single = corners(0).Y
        For i = 1 To 3
            If xmin > corners(i).X Then xmin = corners(i).X
            If ymin > corners(i).Y Then ymin = corners(i).Y
        Next i
        For i = 0 To 3
            corners(i).X -= xmin
            corners(i).Y -= ymin
            corners(i).X += obj.X1.X
            corners(i).Y += obj.X1.Y
        Next i
        ReDim Preserve corners(2)
        g.DrawImage(obj.bitmap, corners)

    End Sub


    Public Sub RuotaLeft()
        Rotate(False)
    End Sub
    Public Sub RuotaRight()
        Rotate(True)
    End Sub

    Private Function InRegion(e As MouseEventArgs, pt As ptObject)
        If pt.draw = Principal.LABEL Then
            If (pt.directionText = "Vertical") Then
                If ((e.Location.X + HscrollX) >= pt.X1.X And (e.Location.X + HscrollX) <= pt.X1.X + pt.font.GetHeight() * 3 / 2 And
                    (e.Location.Y + VscrollY) > pt.X1.Y And (e.Location.Y + VscrollY) <= pt.X1.Y + pt.font.Size * Len(pt.text) + 10) Then
                    Return True
                End If
            Else
                If ((e.Location.X + HscrollX) >= pt.X1.X And (e.Location.X + HscrollX) <= pt.X1.X + pt.font.Size * Len(pt.text) + 10 _
                    And (e.Location.Y + VscrollY) >= pt.X1.Y And (e.Location.Y + VscrollY) <= pt.X1.Y + pt.font.GetHeight() * 3 / 2) Then
                    Return True
                End If
            End If
            Return False
        End If
        If (pt.draw = Principal.CURVE) Then
                calcolaMinMaxCurve(pt)
            If ((e.Location.X + HscrollX) >= pt.X1.X - (pt.rotation * 10) And (e.Location.X + HscrollX) <= pt.X2.X And
                ((e.Location.Y + VscrollY)) >= pt.X1.Y + (pt.rotation * 10)) And (((e.Location.Y + VscrollY)) <= pt.X2.Y + (pt.rotation * 10)) Then
                Return True
            End If
        Else
            If ((e.Location.X + HscrollX) >= pt.X1.X - (pt.rotation * 10) And (e.Location.Y + VscrollY) >= pt.X1.Y + (pt.rotation * 10)) _
                  And ((e.Location.Y + VscrollY) <= pt.X2.Y + (pt.rotation * 10) And (e.Location.X + HscrollX) <= pt.X2.X) Or
                  ((e.Location.X + HscrollX) >= pt.X1.X - (pt.rotation * 10) And (e.Location.Y + VscrollY) <= pt.X1.Y + (pt.rotation * 10)) _
                  And ((e.Location.Y + VscrollY) >= pt.X2.Y + (pt.rotation * 10) And (e.Location.X + HscrollX) <= pt.X2.X) Or
                  ((e.Location.X + HscrollX) <= pt.X1.X - (pt.rotation * 10) And (e.Location.Y + VscrollY) <= pt.X1.Y + (pt.rotation * 10)) _
                  And ((e.Location.Y + VscrollY) >= pt.X2.Y + (pt.rotation * 10) And (e.Location.X + HscrollX) >= pt.X2.X) Or
                  ((e.Location.X + HscrollX) <= pt.X1.X - (pt.rotation * 10) And (e.Location.Y + VscrollY) >= pt.X1.Y + (pt.rotation * 10)) _
                  And ((e.Location.Y + VscrollY) <= pt.X2.Y + (pt.rotation * 10) And (e.Location.X + HscrollX) >= pt.X2.X) Then
                Return True
            End If
        End If
        Return False
    End Function

    Private Function GetObjPointToFill(ptClicked As Point) As ptObject
        For Each pt In lstDrawOject
            If (ptClicked.X > pt.X1.X And ptClicked.Y > pt.X1.Y) _
                        And (ptClicked.Y < pt.X2.Y And ptClicked.X < pt.X2.X) Or
                        (ptClicked.X > pt.X1.X And ptClicked.Y < pt.X1.Y) _
                        And (ptClicked.Y > pt.X2.Y And ptClicked.X < pt.X2.X) Or
                        (ptClicked.X < pt.X1.X And ptClicked.Y < pt.X1.Y) _
                        And (ptClicked.Y > pt.X2.Y And ptClicked.X > pt.X2.X) Or
                        (ptClicked.X < pt.X1.X And ptClicked.Y > pt.X1.Y) _
                        And (ptClicked.Y < pt.X2.Y And ptClicked.X > pt.X2.X) Then
                GetObjPointToFill = pt
                Exit Function
            End If
        Next
        GetObjPointToFill = Nothing

    End Function
    Private Sub DrawGrid(ByRef g As Graphics)
        Dim i As Integer
        Dim penGrid As Pen
        penGrid = New Pen(Color.Gray)
        penGrid.DashStyle = DashStyle.Dot
        For i = 0 To source.Design.Width * 2 Step 20
            g.DrawLine(penGrid, i, 0, i, source.Design.Height * 2)
        Next
        For i = 0 To source.Design.Height * 2 Step 20
            g.DrawLine(penGrid, 0, i, source.Design.Width * 2, i)
        Next
    End Sub
    Private Sub DrawCursorAll(ByRef g As Graphics)
        penSel.DashStyle = DashStyle.DashDotDot
        g.DrawRectangle(penSel, ptSelAll.X, ptSelAll.Y, ptSelAllF.X - ptSelAll.X, ptSelAllF.Y - ptSelAll.Y)
    End Sub

    Private Function MeasureDisplayStringWidth(txt As String, font As Font) As Integer
        Dim textSize As Size = TextRenderer.MeasureText(txt, font)
        Return textSize.Width + 10
    End Function

    Private Sub DrawCursor(ByRef g As Graphics, ByRef pt As ptObject)
        penSel.DashStyle = DashStyle.Dot
        penSel.Width = 1
        If pt.draw = Principal.LABEL Then
            If (pt.directionText = "Vertical") Then
                g.DrawRectangle(penSel, pt.X1.X - 5 - (pt.rotation * 10), pt.X1.Y - 5 + (pt.rotation * 10), pt.font.GetHeight() * 3 / 2, pt.font.Size * Len(pt.text) + 10)
            Else
                g.DrawRectangle(penSel, pt.X1.X - 5 - (pt.rotation * 10), pt.X1.Y - 5 + (pt.rotation * 10), MeasureDisplayStringWidth(pt.text, pt.font), pt.font.GetHeight() * 3 / 2)
            End If
            DrawMenuObject(pt, True)
            Exit Sub
        End If
        If (pt.X2.Y > pt.X1.Y) Then
            If (pt.X2.X > pt.X1.X) Then
                g.DrawRectangle(penSel, pt.X1.X - 5 - (pt.rotation * 10), pt.X1.Y - 5 + (pt.rotation * 10), (pt.X2.X - (pt.X1.X - (pt.rotation * 10))) + 10, (pt.X2.Y - pt.X1.Y) + 10)
            Else
                g.DrawRectangle(penSel, pt.X2.X - 5 - (pt.rotation * 10), pt.X1.Y - 5 + (pt.rotation * 10), (pt.X2.X - (pt.X1.X - (pt.rotation * 10))) + 10, (pt.X2.Y - pt.X1.Y) + 10)
            End If
        Else
            If (pt.X2.X > pt.X1.X) Then
                    g.DrawRectangle(penSel, pt.X1.X - 5 - (pt.rotation * 10), pt.X2.Y - 5 + (pt.rotation * 10), (pt.X2.X - (pt.X1.X - (pt.rotation * 10))) + 10, (pt.X1.Y - pt.X2.Y) + 10)
                Else
                    g.DrawRectangle(penSel, pt.X2.X - 5 - (pt.rotation * 10), pt.X2.Y - 5 + (pt.rotation * 10), (pt.X2.X - (pt.X1.X - (pt.rotation * 10))) + 10, (pt.X1.Y - pt.X2.Y) + 10)
                End If
            End If
        DrawMenuObject(pt)
        If pt.draw <> Principal.BULLONE And pt.draw <> Principal.ELLIPSE Then
            DrawRotateObjectLeft(pt)
            DrawRotateObjectRight(pt)
        End If

    End Sub

    Private Sub DrawMenuObject(ByRef pt As ptObject, Optional IsText As Boolean = False)
        If (lstSelDrawOject.Count = 1) Then
            penSelMenu.DashStyle = DashStyle.Solid
            g.DrawRectangle(penSelMenu, pt.X2.X - 5, pt.X1.Y - 5 + (pt.rotation * 10), 10, 10)
            If IsText Then
                Exit Sub
            End If
            Dim brushFill As New SolidBrush(source._appSettings.ApplicationBackColor)
            g.DrawRectangle(penSelMenu, CInt((pt.X1.X + ((pt.X2.X - (pt.X1.X + (pt.rotation * 10))) / 2))), pt.X1.Y - 5 + (pt.rotation * 10), 10, 10)
            g.FillRectangle(brushFill, CInt((pt.X1.X + ((pt.X2.X - (pt.X1.X + (pt.rotation * 10))) / 2))), pt.X1.Y - 5 + (pt.rotation * 10), 10, 10)
            g.DrawRectangle(penSelMenu, CInt((pt.X1.X + ((pt.X2.X - (pt.X1.X + (pt.rotation * 10))) / 2))), pt.X2.Y - 5 + (pt.rotation * 10), 10, 10)
            g.FillRectangle(brushFill, CInt((pt.X1.X + ((pt.X2.X - (pt.X1.X + (pt.rotation * 10))) / 2))), pt.X2.Y - 5 + (pt.rotation * 10), 10, 10)
            g.DrawRectangle(penSelMenu, pt.X1.X - 5 - (pt.rotation * 10), CInt((pt.X1.Y + ((pt.X2.Y - pt.X1.Y) / 2))) + (pt.rotation * 10), 10, 10)
            g.FillRectangle(brushFill, pt.X1.X - 5 - (pt.rotation * 10), CInt((pt.X1.Y + ((pt.X2.Y - pt.X1.Y) / 2))) + (pt.rotation * 10), 10, 10)
            g.DrawRectangle(penSelMenu, pt.X2.X - 5, CInt((pt.X1.Y + ((pt.X2.Y - pt.X1.Y) / 2))) + (pt.rotation * 10), 10, 10)
            g.FillRectangle(brushFill, pt.X2.X - 5, CInt((pt.X1.Y + ((pt.X2.Y - pt.X1.Y) / 2))) + (pt.rotation * 10), 10, 10)
        End If

    End Sub
    Private Sub DrawRotateObjectLeft(ByRef pt As ptObject, Optional IsText As Boolean = False)
        If (lstSelDrawOject.Count = 1) Then
            Dim bmp As New Bitmap(25, 21)
            Dim szLines() As String
            Dim arrPixel(5) As String
            Dim i As Integer
            szLines = cursorTurnRight.Split(";")
            For i = 0 To szLines.Length() - 2
                arrPixel = szLines(i).Split(",")
                If (CInt(arrPixel(2)) <> 255 And CInt(arrPixel(3)) <> 255 And CInt(arrPixel(4)) <> 255) Then
                    bmp.SetPixel(CInt(arrPixel(0)), CInt(arrPixel(1)), Color.FromArgb(CInt(arrPixel(2)), CInt(arrPixel(3)), CInt(arrPixel(4))))
                End If
            Next
            g.DrawImage(bmp, pt.X2.X - 5, pt.X2.Y - 5 + (pt.rotation * 10))
        End If
    End Sub
    Private Sub DrawRotateObjectRight(ByRef pt As ptObject, Optional IsText As Boolean = False)
        If (lstSelDrawOject.Count = 1) Then
            Dim bmp As New Bitmap(25, 21)
            Dim szLines() As String
            Dim arrPixel(5) As String
            Dim i As Integer
            szLines = cursorTurnLeft.Split(";")
            For i = 0 To szLines.Length() - 2
                arrPixel = szLines(i).Split(",")
                If (CInt(arrPixel(2)) <> 255 And CInt(arrPixel(3)) <> 255 And CInt(arrPixel(4)) <> 255) Then
                    bmp.SetPixel(CInt(arrPixel(0)), CInt(arrPixel(1)), Color.FromArgb(CInt(arrPixel(2)), CInt(arrPixel(3)), CInt(arrPixel(4))))
                End If
            Next
            g.DrawImage(bmp, pt.X1.X - 5 - (pt.rotation * 10), pt.X1.Y - 5 + (pt.rotation * 10))
        End If
    End Sub
    Public Function getObjCount() As Integer
        Return lstDrawOject.Count
    End Function

    Private Sub DrawCurve(pt As ptObject)
        On Error Resume Next
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        Dim ptCurve As New List(Of Drawing.PointF)
        If pt.lstPtCurve.Count > 0 Then
            For Each p In pt.lstPtCurve
                ptCurve.Add(p)
            Next
            g.DrawLines(penDraw, ptCurve.ToArray)
            Dim PC(ptCurve.Count - 1) As PointF
            For i = 0 To ptCurve.Count - 1
                PC(i) = ptCurve(i)
            Next
            If pt.brushBitmap <> Nothing Then
                oBmp = New Bitmap(CStr(pt.brushBitmap))
                oBrushTexture = New TextureBrush(oBmp)
                g.FillPolygon(oBrushTexture, PC)
            Else
                Dim brushFill As New LinearGradientBrush(PC(0), PC(ptCurve.Count - 1), pt.FillColor, pt.FillColor2)
                g.FillPolygon(brushFill, PC)
            End If
        End If

    End Sub

    Private Sub DrawEllipse(pt As ptObject)
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        If pt.dCube > 0 Then
            Dim i As Integer
            Dim penD As New Pen(brushFill)
            For i = 1 To pt.dCube
                g.DrawEllipse(penD, New Rectangle(New Point(pt.X1.X + i, pt.X1.Y - i), New Size(pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)))
            Next
        End If
        g.DrawEllipse(penDraw, New Rectangle(pt.X1, New Size(pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)))
        If pt.brushBitmap <> Nothing Then
            oBmp = New Bitmap(CStr(pt.brushBitmap))
            oBrushTexture = New TextureBrush(oBmp)
            g.FillEllipse(oBrushTexture, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        Else
            g.FillEllipse(brushFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        End If

    End Sub
    Private Sub DrawRectangle(pt As ptObject)
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        g.DrawRectangle(penDraw, New Rectangle(pt.X1, New Size(pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)))
        If pt.brushBitmap <> Nothing Then
            oBmp = New Bitmap(pt.brushBitmap)
            oBrushTexture = New TextureBrush(oBmp)
            g.FillRectangle(oBrushTexture, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        Else
            g.FillRectangle(brushFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        End If
    End Sub

    Private Sub DrawTrend(pt As ptObject)
        Dim brushFore As New SolidBrush(Color.Gray)
        Dim brushForePen As New SolidBrush(Color.Red)
        Dim brushForePen2 As New SolidBrush(Color.Blue)
        Dim brushForePenAxes As New SolidBrush(Color.Black)
        Dim penDraw As New Pen(brushFore, 1)
        Dim penDrawPen As New Pen(brushForePen, 1)
        Dim penDrawAxes As New Pen(brushForePenAxes, 1)
        Dim penDrawPen2 As New Pen(brushForePen2, 1)
        penDraw.DashStyle = DashStyle.DashDot
        penDrawAxes.DashStyle = DashStyle.Solid
        Dim P As New Pen(pt.ForeColor, 2)
        P.DashStyle = DashStyle.Solid
        P.EndCap = Drawing2D.LineCap.DiamondAnchor
        g.DrawLine(P, pt.X1.X, pt.X2.Y, pt.X2.X, pt.X2.Y)
        g.DrawLine(P, pt.X1.X, pt.X2.Y, pt.X1.X, pt.X2.Y - (pt.X2.Y - pt.X1.Y))
        Dim dx As Integer = (pt.X2.X - pt.X1.X)
        Dim dy As Integer = (pt.X2.Y - pt.X1.Y)
        For i = 0 To dx Step 10
            g.DrawLine(penDraw, pt.X1.X + i, pt.X2.Y, pt.X1.X + i, pt.X1.Y)
        Next
        For i = 0 To dy Step 10
            g.DrawLine(penDraw, pt.X1.X, pt.X2.Y - i, pt.X2.X, pt.X2.Y - i)
        Next
        For i = 0 To dx Step 10
            g.DrawLine(penDrawAxes, pt.X1.X + i, pt.X2.Y, pt.X1.X + i, pt.X2.Y - 3)
        Next
        For i = 0 To dy Step 10
            g.DrawLine(penDrawAxes, pt.X1.X, pt.X2.Y - i, pt.X1.X + 3, pt.X2.Y - i)
        Next
        Dim data As String = "1,3;4,3;8,8;15,9;25,45;30,70;100,150;120,171;78,188;200,300"
        Dim data2 As String = "1,13;4,13;8,18;15,19;25,145;30,170;100,210;120,350;78,400;200,350"

        Dim szPoint() As String = data.Split(";")
        Dim szPoint2() As String = data2.Split(";")
        Dim x As Integer = pt.X1.X
        Dim y As Integer = pt.X2.Y
        Dim x2 As Integer = pt.X1.X
        Dim y2 As Integer = pt.X2.Y

        For j = 0 To szPoint.Length - 1
            Dim pXY() As String = szPoint(j).Split(",")
            g.DrawLine(penDrawPen, x, y, pt.X1.X + CInt(pXY(0)), pt.X2.Y - CInt(pXY(1)))
            x = pt.X1.X + CInt(pXY(0))
            y = pt.X2.Y - CInt(pXY(1))
            g.DrawEllipse(penDrawPen, pt.X1.X + CInt(pXY(0)) - 2, pt.X2.Y - CInt(pXY(1)) - 2, 4, 4)
            g.FillEllipse(brushForePen, pt.X1.X + CInt(pXY(0)) - 2, pt.X2.Y - CInt(pXY(1)) - 2, 4, 4)

            Dim p2XY() As String = szPoint2(j).Split(",")

            g.DrawLine(penDrawPen2, x2, y2, pt.X1.X + CInt(p2XY(0)), pt.X2.Y - CInt(p2XY(1)))
            x2 = pt.X1.X + CInt(p2XY(0))
            y2 = pt.X2.Y - CInt(p2XY(1))
            g.DrawEllipse(penDrawPen2, pt.X1.X + CInt(p2XY(0)) - 2, pt.X2.Y - CInt(p2XY(1)) - 2, 4, 4)
            g.FillEllipse(brushForePen2, pt.X1.X + CInt(p2XY(0)) - 2, pt.X2.Y - CInt(p2XY(1)) - 2, 4, 4)

        Next



    End Sub
    Private Sub DrawT_Sect(pt As ptObject)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select

        g.DrawEllipse(penDraw, pt.X1.X, pt.X1.Y, pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)
        g.DrawLine(penDraw, pt.X1.X, pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2), pt.X2.X, pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2))
        Dim i As Integer
        For i = 0 To 245
            Dim rr As Integer
            Dim gr As Integer
            Dim br As Integer
            rr = 245 - i
            gr = 240 - (i - 5)
            br = 230 - (i - 15)
            Dim penDr As New Pen(Color.FromArgb(rr, gr, br))

            Dim f As Double = i
            Dim x As Integer = pt.X1.X + CInt(CInt(pt.X2.X - pt.X1.X) / 2) + (CInt(pt.X2.X - pt.X1.X) / 2) * Math.Cos(f)
            Dim y As Integer = pt.X2.Y - (CInt(CInt(pt.X2.Y - pt.X1.Y) / 2) + CInt((pt.X2.Y - pt.X1.Y) / 2) * Math.Sin(f))

            g.DrawLine(penDr, pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2), x, y)

        Next i


    End Sub
    Private Sub DrawLSec(pt As ptObject)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        Dim bl As New GraphicsPath()
        Dim dx As Integer = CInt((pt.X2.X - pt.X1.X) / 2)
        Dim dy As Integer = CInt((pt.X2.Y - pt.X1.Y) / 2)

        If pt.dCube > 0 Then
            Dim ptPoin As New List(Of Drawing.PointF)
            dx = CInt(((pt.X2.X + pt.dCube) - (pt.X1.X + pt.dCube)) / 2)
            dy = CInt(((pt.X2.Y - pt.dCube) - (pt.X1.Y - pt.dCube)) / 2)
            ptPoin.Add(New PointF(pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube))
            ptPoin.Add(New PointF(pt.X1.X + dx + pt.dCube, pt.X1.Y - pt.dCube))
            ptPoin.Add(New PointF(pt.X1.X + dx + pt.dCube, (pt.X1.Y + dy) - pt.dCube))
            ptPoin.Add(New PointF(pt.X2.X + pt.dCube, (pt.X1.Y + dy) - pt.dCube))
            ptPoin.Add(New PointF(pt.X2.X + pt.dCube, pt.X2.Y - pt.dCube))
            ptPoin.Add(New PointF(pt.X1.X + pt.dCube, pt.X2.Y - pt.dCube))
            bl.StartFigure()
            bl.AddPolygon(ptPoin.ToArray)
            g.DrawPath(penDraw, bl)
            If pt.brushBitmap = "" Then
                g.FillPath(brushFill, bl)
            Else
                Dim oBmp As Bitmap
                Dim oBrushTexture As TextureBrush
                oBmp = New Bitmap(pt.brushBitmap)
                oBrushTexture = New TextureBrush(oBmp)
                g.FillPath(oBrushTexture, bl)
            End If
            bl.CloseFigure()
            bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube)
            bl.AddLine(pt.X1.X + dx + pt.dCube, pt.X1.Y - pt.dCube, pt.X1.X + dx, pt.X1.Y)
            g.DrawPath(penDraw, bl)
            bl.Reset()
            bl.AddLine(pt.X1.X + dx + pt.dCube, (pt.X1.Y + dy) - pt.dCube, pt.X1.X + dx, pt.X1.Y + dy)
            g.DrawPath(penDraw, bl)
            bl.Reset()
            bl.AddLine(pt.X2.X + pt.dCube, (pt.X1.Y + dy) - pt.dCube, pt.X2.X, pt.X1.Y + dy)
            g.DrawPath(penDraw, bl)
            bl.Reset()
            bl.AddLine(pt.X2.X, pt.X2.Y, pt.X2.X + pt.dCube, pt.X2.Y - pt.dCube)
            g.DrawPath(penDraw, bl)

            bl.Reset()
        End If
        dx = CInt(((pt.X2.X - pt.dCube) - (pt.X1.X - pt.dCube)) / 2)
        dy = CInt(((pt.X2.Y - pt.dCube) - (pt.X1.Y - pt.dCube)) / 2)

        Dim ptPoints As New List(Of Drawing.PointF)
        ptPoints.Add(New PointF(pt.X1.X, pt.X1.Y))
        ptPoints.Add(New PointF(pt.X1.X + dx, pt.X1.Y))
        ptPoints.Add(New PointF(pt.X1.X + dx, pt.X1.Y + dy))
        ptPoints.Add(New PointF(pt.X2.X, pt.X1.Y + dy))
        ptPoints.Add(New PointF(pt.X2.X, pt.X2.Y))
        ptPoints.Add(New PointF(pt.X1.X, pt.X2.Y))
        bl.StartFigure()
        bl.AddPolygon(ptPoints.ToArray)
        g.DrawPath(penDraw, bl)
        If pt.brushBitmap = "" Then
            g.FillPath(brushFill, bl)
        Else
            Dim oBmp As Bitmap
            Dim oBrushTexture As TextureBrush
            oBmp = New Bitmap(pt.brushBitmap)
            oBrushTexture = New TextureBrush(oBmp)
            g.FillPath(oBrushTexture, bl)
        End If

    End Sub
    Private Sub DrawTriangle(pt As ptObject)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        Dim bl As New GraphicsPath()
        If pt.dCube > 0 Then
            Dim ptPoin As New List(Of Drawing.PointF)
            ptPoin.Add(New PointF(pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube))
            ptPoin.Add(New PointF(pt.X1.X + pt.dCube, pt.X2.Y - pt.dCube))
            ptPoin.Add(New PointF(pt.X2.X + pt.dCube, pt.X2.Y - pt.dCube))
            bl.StartFigure()
            bl.AddPolygon(ptPoin.ToArray)
            bl.StartFigure()
            bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube)
            bl.StartFigure()
            bl.AddLine(pt.X2.X, pt.X2.Y, pt.X2.X + pt.dCube, pt.X2.Y - pt.dCube)
            bl.StartFigure()
            bl.AddLine(pt.X1.X, pt.X2.Y, pt.X1.X + pt.dCube, pt.X2.Y - pt.dCube)
            g.DrawPath(penDraw, bl)
            If pt.brushBitmap = "" Then
                g.FillPath(brushFill, bl)
            Else
                Dim oBmp As Bitmap
                Dim oBrushTexture As TextureBrush
                oBmp = New Bitmap(pt.brushBitmap)
                oBrushTexture = New TextureBrush(oBmp)
                g.FillPath(oBrushTexture, bl)
            End If

            bl.CloseFigure()
            bl.Reset()
        End If
        Dim ptP As New List(Of Drawing.PointF)
        ptP.Add(New PointF(pt.X1.X, pt.X1.Y))
        ptP.Add(New PointF(pt.X1.X, pt.X2.Y))
        ptP.Add(New PointF(pt.X2.X, pt.X2.Y))
        bl.StartFigure()
        bl.AddPolygon(ptP.ToArray)
        g.DrawPath(penDraw, bl)
        If pt.brushBitmap = "" Then
            g.FillPath(brushFill, bl)
        Else
            Dim oBmp As Bitmap
            Dim oBrushTexture As TextureBrush
            oBmp = New Bitmap(pt.brushBitmap)
            oBrushTexture = New TextureBrush(oBmp)
            g.FillPath(oBrushTexture, bl)
        End If
    End Sub
    Private Sub DrawBullone(pt As ptObject)
        If pt.brushBitmap Is Nothing Then
            DrawBulloneWithoutTexture(pt)
        Else
            DrawBulloneWithTexture(pt)
        End If
    End Sub
    Private Sub DrawBulloneWithTexture(pt As ptObject)
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        If pt.brushBitmap = "" Then
            DrawBulloneWithoutTexture(pt)
            Return
        End If
        oBmp = New Bitmap(pt.brushBitmap)
        oBrushTexture = New TextureBrush(oBmp)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        Dim d As Integer = CInt((pt.X2.X - pt.X1.X) / 3)
        Dim bl As New GraphicsPath()
        bl.AddEllipse(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2) - CInt(d / 2), pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2) - CInt(d / 2), d, d)
        bl.StartFigure()
        bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X, pt.X2.Y)
        bl.AddLine(pt.X2.X, pt.X1.Y, pt.X2.X, pt.X2.Y)
        bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X1.Y - CInt((pt.X2.Y - pt.X1.Y) / 2))
        bl.AddLine(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X1.Y - CInt((pt.X2.Y - pt.X1.Y) / 2), pt.X2.X, pt.X1.Y)
        bl.AddLine(pt.X1.X, pt.X2.Y, pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X2.Y + CInt((pt.X2.Y - pt.X1.Y) / 2))
        bl.AddLine(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X2.Y + CInt((pt.X2.Y - pt.X1.Y) / 2), pt.X2.X, pt.X2.Y)
        g.DrawPath(penDraw, bl)
        g.FillPath(oBrushTexture, bl)
        bl.Reset()
        bl.AddEllipse(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2) - CInt(d / 2), pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2) - CInt(d / 2), d, d)
        g.DrawPath(penDraw, bl)
        g.FillPath(brushFill, bl)
    End Sub
    Private Sub DrawBulloneWithoutTexture(pt As ptObject)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        Dim d As Integer = CInt((pt.X2.X - pt.X1.X) / 3)
        Dim bl As New GraphicsPath()
        bl.AddEllipse(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2) - CInt(d / 2), pt.X1.Y + CInt((pt.X2.Y - pt.X1.Y) / 2) - CInt(d / 2), d, d)
        bl.StartFigure()
        bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X, pt.X2.Y)
        bl.StartFigure()
        bl.AddLine(pt.X2.X, pt.X1.Y, pt.X2.X, pt.X2.Y)
        bl.StartFigure()
        bl.AddLine(pt.X1.X, pt.X1.Y, pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X1.Y - CInt((pt.X2.Y - pt.X1.Y) / 2))
        bl.StartFigure()
        bl.AddLine(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X1.Y - CInt((pt.X2.Y - pt.X1.Y) / 2), pt.X2.X, pt.X1.Y)
        bl.StartFigure()
        bl.AddLine(pt.X1.X, pt.X2.Y, pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X2.Y + CInt((pt.X2.Y - pt.X1.Y) / 2))
        bl.StartFigure()
        bl.AddLine(pt.X1.X + CInt((pt.X2.X - pt.X1.X) / 2), pt.X2.Y + CInt((pt.X2.Y - pt.X1.Y) / 2), pt.X2.X, pt.X2.Y)
        g.DrawPath(penDraw, bl)
        g.FillPath(brushFill, bl)
        g.ResetTransform()
    End Sub
    Private Sub DrawLabel(pt As ptObject)
        Dim oBmp As Bitmap
        Dim brush As LinearGradientBrush
        Dim oBrusht As TextureBrush
        If pt.brushBitmap <> Nothing Then
            oBmp = New Bitmap(CStr(pt.brushBitmap))
            oBrusht = New TextureBrush(oBmp)
            If (pt.directionText = "Vertical") Then
                Dim strf As StringFormat = New StringFormat(StringFormatFlags.DirectionVertical)
                g.DrawString(pt.text, pt.font, oBrusht, pt.X1.X, pt.X1.Y, strf)
            Else
                g.DrawString(pt.text, pt.font, oBrusht, pt.X1.X, pt.X1.Y)
            End If
        Else
            brush = New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
            If (pt.directionText = "Vertical") Then
                Dim strf As StringFormat = New StringFormat(StringFormatFlags.DirectionVertical)
                g.DrawString(pt.text, pt.font, brush, pt.X1.X, pt.X1.Y, strf)
            Else
                g.DrawString(pt.text, pt.font, brush, pt.X1.X, pt.X1.Y)
            End If
        End If
    End Sub
    Private Sub DrawLine(pt As ptObject)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        g.DrawLine(penDraw, pt.X1, pt.X2)
    End Sub
    Private Sub DrawArrow(pt As ptObject, arrowStart As Boolean)
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        If arrowStart Then
            drawLineArrow.ArrowEnd(g, pt, penDraw.DashStyle)
        Else
            drawLineArrow.ArrowStartEnd(g, pt, penDraw.DashStyle)
        End If
    End Sub
    Private Sub DrawCubo(pt As ptObject)
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        Dim brushFore As New SolidBrush(pt.ForeColor)
        Dim penDraw As New Pen(brushFore, pt.penSize)
        Dim brushFill As New LinearGradientBrush(pt.X1, pt.X2, pt.FillColor, pt.FillColor2)
        Select Case pt.penStyle
            Case Principal.SOLID_STYLE
                penDraw.DashStyle = DashStyle.Solid
            Case Principal.DASH_STYLE
                penDraw.DashStyle = DashStyle.Dash
            Case Principal.DOT_STYLE
                penDraw.DashStyle = DashStyle.Dot
            Case Principal.DASDOT_STYLE
                penDraw.DashStyle = DashStyle.DashDot
        End Select
        g.DrawRectangle(penDraw, New Rectangle(pt.X1, New Size(pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)))
        g.DrawRectangle(penDraw, New Rectangle(New Point(pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube), New Size((pt.X2.X + pt.dCube) - (pt.X1.X + pt.dCube), ((pt.X2.Y - pt.dCube) - (pt.X1.Y - pt.dCube)))))
        g.DrawLine(penDraw, pt.X1.X, pt.X1.Y, pt.X1.X + pt.dCube, pt.X1.Y - pt.dCube)
        g.DrawLine(penDraw, pt.X1.X, pt.X2.Y, pt.X1.X + pt.dCube, pt.X2.Y - pt.dCube)
        g.DrawLine(penDraw, pt.X2.X, pt.X2.Y, pt.X2.X + pt.dCube, pt.X2.Y - pt.dCube)
        g.DrawLine(penDraw, pt.X2.X, pt.X1.Y, pt.X2.X + pt.dCube, pt.X1.Y - pt.dCube)
        If pt.brushBitmap <> Nothing Then
            oBmp = New Bitmap(pt.brushBitmap)
            oBrushTexture = New TextureBrush(oBmp)
            g.FillRectangle(oBrushTexture, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        Else
            g.FillRectangle(brushFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y) - 1)
        End If

    End Sub
    Private Sub DrawPen(pt As ptObject)
        Dim Person As New GraphicsPath()
        Person.AddEllipse(23 + pt.X1.X, 1 + pt.X1.Y, 14, 14)
        Person.AddLine(pt.X1.X + 18, 16 + pt.X1.Y, 42 + pt.X1.X, 16 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 50, 40 + pt.X1.Y, 44 + pt.X1.X, 42 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 38, 25 + pt.X1.Y, 37 + pt.X1.X, 42 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 45, 75 + pt.X1.Y, 37 + pt.X1.X, 75 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 30, 50 + pt.X1.Y, 23 + pt.X1.X, 75 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 16, 75 + pt.X1.Y, 23 + pt.X1.X, 42 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 22, 25 + pt.X1.Y, 16 + pt.X1.X, 42 + pt.X1.Y)
        Person.AddLine(pt.X1.X + 10, 40 + pt.X1.Y, 18 + pt.X1.X, 16 + pt.X1.Y)
        g.DrawPath(Pens.Blue, Person)
        Dim oRect As New Rectangle(0, 0, 100, 100)
        Dim oBrush As New LinearGradientBrush(oRect, Color.White, Color.Red, LinearGradientMode.Vertical)
        g.FillPath(oBrush, Person)
        g.ResetTransform()
    End Sub

    Public Sub Draw()
        On Error Resume Next
        Dim oBmp As Bitmap
        Dim oBrushTexture As TextureBrush
        g = Graphics.FromImage(bm)
        g.Transform = gmatrix
        g.Clear(source._designSettings.DesignBackColor)
        lstDrawOject = lstDrawOject.Cast(Of ptObject)() _
        .OrderBy(Function(i As ptObject) Convert.ToBoolean(i.bringToFront)) _
        .ToList()
        lstSelDrawOject = lstSelDrawOject.Cast(Of ptObject)() _
        .OrderBy(Function(i As ptObject) Convert.ToBoolean(i.bringToFront)) _
        .ToList()
        If source.nMode = Principal.DELETE Then
            source.nMode = Principal.SELECTION
            For Each ptSel In lstSelDrawOject
                For Each ptO In lstDrawOject
                    If (ptO.name = ptSel.name) Then
                        lstDrawOject.Remove(ptO)
                        lstRedoDrawOject.Add(ptO)
                        Exit For
                    End If
                Next
            Next
            lstSelDrawOject.Clear()
            lstTempDrawOject.Clear()
        End If
        For Each pt In lstDrawOject
            If (pt.rotation <> 0 And pt.draw <> Principal.IIMAGE) Then
                g.RotateTransform(pt.rotation)
            End If
            Select Case pt.draw
                Case Principal.LINE
                    DrawLine(pt)
                Case Principal.LINEARROW
                    DrawArrow(pt, True)
                Case Principal.LINEARROWSE
                    DrawArrow(pt, False)
                Case Principal.PEN
                    DrawPen(pt)
                Case Principal.RECTANGLE
                    DrawRectangle(pt)
                Case Principal.L_SEC
                    DrawLSec(pt)
                Case Principal.CUBO
                    DrawCubo(pt)
                Case Principal.CURVE
                    DrawCurve(pt)
                Case Principal.ELLIPSE
                    DrawEllipse(pt)
                Case Principal.BULLONE
                    DrawBullone(pt)
                Case Principal.T_SECT
                    DrawT_Sect(pt)
                Case Principal.TRIANGLE
                    DrawTriangle(pt)
                Case Principal.IIMAGE
                    If (pt.rotation = 0) Then
                        DDrawImage(pt)
                    Else
                        drawImageRot(pt)
                    End If
                Case Principal.LABEL
                    DrawLabel(pt)
                Case Principal.TREND
                    DrawTrend(pt)
            End Select
            If (pt.rotation <> 0) Then
                g.ResetTransform()
            End If
        Next

        For Each pt In lstTempDrawOject
            If (pt.rotation <> 0 And pt.draw <> Principal.IIMAGE) Then
                g.RotateTransform(pt.rotation)
            End If
            Select Case pt.draw
                Case Principal.LINE
                    DrawLine(pt)
                Case Principal.LINEARROW
                    DrawArrow(pt, True)
                Case Principal.LINEARROWSE
                    DrawArrow(pt, False)
                Case Principal.RECTANGLE
                    DrawRectangle(pt)
                Case Principal.L_SEC
                    DrawLSec(pt)
                Case Principal.CUBO
                    DrawCubo(pt)
                Case Principal.ELLIPSE
                    DrawEllipse(pt)
                Case Principal.BULLONE
                    DrawBullone(pt)
                Case Principal.T_SECT
                    DrawT_Sect(pt)
                Case Principal.TRIANGLE
                    DrawTriangle(pt)
                Case Principal.IIMAGE
                    If (pt.rotation = 0) Then
                        DDrawImage(pt)
                    Else
                        drawImageRot(pt)
                    End If
                Case Principal.TREND
                    DrawTrend(pt)
            End Select
            If (pt.rotation <> 0) Then
                g.ResetTransform()
            End If

        Next
        For Each pt In lstSelDrawOject
            If (pt.rotation <> 0 And pt.draw <> Principal.IIMAGE) Then
                g.RotateTransform(pt.rotation)
            End If
            Select Case pt.draw
                Case Principal.LINE
                    DrawLine(pt)
                Case Principal.LINEARROW
                    DrawArrow(pt, True)
                Case Principal.LINEARROWSE
                    DrawArrow(pt, False)
                Case Principal.PEN
                    DrawPen(pt)
                Case Principal.RECTANGLE
                    DrawRectangle(pt)
                Case Principal.L_SEC
                    DrawLSec(pt)
                Case Principal.CUBO
                    DrawCubo(pt)
                Case Principal.CURVE
                    DrawCurve(pt)
                    calcolaMinMaxCurve(pt)
                Case Principal.ELLIPSE
                    DrawEllipse(pt)
                Case Principal.BULLONE
                    DrawBullone(pt)
                Case Principal.T_SECT
                    DrawT_Sect(pt)
                Case Principal.TRIANGLE
                    DrawTriangle(pt)
                Case Principal.IIMAGE
                    If (pt.rotation = 0) Then
                        DDrawImage(pt)
                    Else
                        drawImageRot(pt)
                    End If
                Case Principal.LABEL
                    DrawLabel(pt)
                Case Principal.TREND
                    DrawTrend(pt)
            End Select
            If (pt.rotation <> 0) Then
                g.ResetTransform()
            End If
            DrawCursor(g, pt)
        Next
        If (lstCurveDrawOject.Count <> 0) Then
            Dim penLine As New Pen(source._designSettings.DesignForeColor)
            penLine.MiterLimit = 0
            Dim ptCurve As New List(Of Drawing.PointF)
            Dim fd As Boolean
            For Each ptC In lstCurveDrawOject
                fd = False
                For Each p In ptCurve
                    If p.X = ptC.X And p.Y = ptC.Y Then
                        fd = True
                    End If
                Next
                If Not fd Then
                    ptCurve.Add(ptC)
                End If
            Next
            If (ptCurve.Count > 1) Then
                g.DrawLines(penLine, ptCurve.ToArray())
                Dim PC(ptCurve.Count) As PointF
                For i = 0 To ptCurve.Count - 1
                    PC(i) = ptCurve(i)
                Next
                If source._designSettings.DesignBitmap <> Nothing Then
                    oBmp = New Bitmap(CStr(source._designSettings.DesignBitmap))
                    oBrushTexture = New TextureBrush(oBmp)
                    g.FillPolygon(oBrushTexture, PC)
                Else
                    Dim brushFill As New LinearGradientBrush(PC(0), PC(ptCurve.Count - 1), source._designSettings.DesignFillColor, source._designSettings.DesignFillColor2)
                    g.FillPolygon(brushFill, PC)
                End If
            End If
            ptCurve = Nothing
            penLine = Nothing
        End If
        lstTempDrawOject.Clear()
        If source.nMode = Principal.FILL And ptFill <> Nothing Then
            Dim pt As ptObject
            pt = GetObjPointToFill(ptFill)
            Dim brsFill As New LinearGradientBrush(pt.X1, pt.X2, source._designSettings.DesignFillColor, source._designSettings.DesignFillColor2)
            If (pt.name <> Nothing) Then
                Select Case pt.draw
                    Case Principal.RECTANGLE
                        g.FillRectangle(brsFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y - 1))
                    Case Principal.CUBO
                        g.FillRectangle(brsFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y - 1))
                        g.FillRectangle(brsFill, New Rectangle(New Point(pt.X1.X + pt.dCube + 1, pt.X1.Y - (pt.dCube - 1)), New Size((pt.X2.X + pt.dCube + 1) - (pt.X1.X + pt.dCube + 1), ((pt.X2.Y - (pt.dCube - 1)) - (pt.X1.Y - (pt.dCube - 1))))))
                    Case Principal.ELLIPSE
                        g.FillEllipse(brsFill, pt.X1.X + 1, pt.X1.Y + 1, (pt.X2.X - pt.X1.X) - 1, (pt.X2.Y - pt.X1.Y - 1))
                    Case Principal.CURVE
                        Dim P(pt.lstPtCurve.Count) As PointF
                        For i = 0 To pt.lstPtCurve.Count - 1
                            P(i) = pt.lstPtCurve(i)
                        Next
                        g.FillPolygon(brsFill, P)
                End Select
                lstDrawOject.Remove(pt)
                pt.FillColor = source._designSettings.DesignFillColor
                pt.FillColor2 = source._designSettings.DesignFillColor2
                pt.brushBitmap = source._designSettings.DesignBitmap
                lstDrawOject.Add(pt)
            End If
            ptFill = Nothing
        End If
        If Principal.SELECTION And bMouseDown And ptSelAll <> Nothing Then
            DrawCursorAll(g)
        End If
        If (source.bGrid) Then
            DrawGrid(g)
        End If

        If bMouseDown Then
            drawPosition()
        End If
        source.Design.CreateGraphics().DrawImage(bm, New Point(source.Design.AutoScrollPosition.X, source.Design.AutoScrollPosition.Y))
    End Sub

    Private Sub drawPosition()
        Dim penPosition As New Pen(Principal._designSettings.DesignForeColor)
        Dim brsFill As New SolidBrush(Principal._designSettings.DesignForeColor)
        Dim brsString As New SolidBrush(source._designSettings.DesignBackColor)
        Dim fnt As New Font("Arial", 8)
        g.DrawRectangle(penPosition, CurrentMouseX - 1, CurrentMouseY + 20, 50, 20)
        g.FillRectangle(brsFill, New Rectangle(CurrentMouseX, CurrentMouseY + 21, 49, 19))
        g.DrawString(Str(CurrentMouseX) & "," & CStr(CurrentMouseY), fnt, brsString, New PointF(CurrentMouseX, CurrentMouseY + 23))

    End Sub

    Private Sub DDrawImage(ByRef pt As ptObject)
        pt.bitmap = AdjustImage(pt.bitmap, pt.brightness, pt.contrast, pt.gamma)
        g.DrawImage(pt.bitmap, pt.X1.X, pt.X1.Y, pt.X2.X - pt.X1.X, pt.X2.Y - pt.X1.Y)
    End Sub


    Public Function AdjustImage(original As Bitmap, Optional brightness As Double = 1.0F,
                                Optional contrast As Double = 1.0F, Optional gamma As Double = 1.0F) As Bitmap
        Dim adjustedImage = New Bitmap(original.Width, original.Height)

        Dim adjustedBrightness As Double = brightness - 1.0F


        Dim cMatrix As New ColorMatrix(New Single()() _
                     {
                     New Single() {contrast, 0, 0, 0, 0}, _
                     New Single() {0, contrast, 0, 0, 0}, _
                     New Single() {0, 0, contrast, 0, 0}, _
                     New Single() {0, 0, 0, 1.0F, 0}, _
                     New Single() {adjustedBrightness, adjustedBrightness, adjustedBrightness, 0, 1}})


        Dim ia As New ImageAttributes()
        ia.ClearColorMatrix()
        ia.SetColorMatrix(cMatrix, ColorMatrixFlag.Default, ColorAdjustType.Bitmap)
        ia.SetGamma(gamma, ColorAdjustType.Bitmap)

        Dim g As Graphics = Graphics.FromImage(adjustedImage)
        g.DrawImage(original, New Rectangle(Point.Empty, adjustedImage.Size), 0, 0, original.Width, original.Height, GraphicsUnit.Pixel, ia)

        Return adjustedImage
    End Function
    Public Sub Clear()
        source.nMode = Principal.CLEAR
    End Sub
    Public Sub KeyUp(sender As Object, e As KeyEventArgs)
        If (e.KeyCode = Keys.Control) Then
            ctrlKey = False
        End If
    End Sub

    Public Sub ZooomP()
        gmatrix.Scale(1.01, 1.01)
        Draw()
    End Sub
    Public Sub ZooomM()
        gmatrix.Scale(0.99, 0.99)
        Draw()
    End Sub

    Public Sub MoveWithKeys(key As Keys)
        lstTempDrawOject.Clear()

        For Each p In lstSelDrawOject
            If p.draw = Principal.CURVE Then
                Dim lstTempPtCurve As New ArrayList
                For Each o In p.lstPtCurve
                    Select Case key
                        Case Keys.Right
                            o.X += 1
                        Case Keys.Left
                            o.X -= 1
                        Case Keys.Up
                            o.Y -= 1
                        Case Keys.Down
                            o.Y += 1
                    End Select
                    lstTempPtCurve.Add(o)
                Next
                p.lstPtCurve.Clear()
                For Each o In lstTempPtCurve
                    p.lstPtCurve.Add(o)
                Next
            Else
                Select Case key
                    Case Keys.Right
                        p.X1.X += 1
                        p.X2.X += 1
                        If p.draw = Principal.CURVE Then
                            Dim lstTempPtCurve As New ArrayList
                            For Each o In p.lstPtCurve
                                o.X += 1
                                lstTempPtCurve.Add(o)
                            Next
                            p.lstPtCurve.Clear()
                            For Each o In lstTempPtCurve
                                p.lstPtCurve.Add(o)
                            Next
                        End If
                    Case Keys.Left
                        p.X1.X -= 1
                        p.X2.X -= 1
                    Case Keys.Up
                        p.X1.Y -= 1
                        p.X2.Y -= 1
                    Case Keys.Down
                        p.X1.Y += 1
                        p.X2.Y += 1
                End Select
            End If
            lstTempDrawOject.Add(p)
        Next
        For Each p In lstTempDrawOject
            For Each px In lstDrawOject
                If px.name = p.name Then
                    lstDrawOject.Remove(px)
                    lstDrawOject.Add(p)
                    Exit For
                End If
            Next
            For Each px In lstSelDrawOject
                If px.name = p.name Then
                    lstSelDrawOject.Remove(px)
                    lstSelDrawOject.Add(p)
                    Exit For
                End If
            Next
        Next
    End Sub
    Public Sub KeyDown(sender As Object, e As KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Z
                If ctrlKey Then
                    lstRedoDrawOject = lstRedoDrawOject.Cast(Of ptObject)().OrderByDescending(Function(i As ptObject) Convert.ToInt32(i.orderDesign)).ToList()
                    For Each pt In lstRedoDrawOject
                        lstDrawOject.Add(pt)
                        lstRedoDrawOject.Remove(pt)
                        Draw()
                        Exit Sub
                    Next
                End If
            Case Keys.E
                gmatrix.RotateAt(-10, New Point(source.ClientSize.Width / 2, source.ClientSize.Height / 2))
            Case Keys.K
                gmatrix.RotateAt(10, New Point(source.ClientSize.Width / 2, source.ClientSize.Height / 2))
            Case Keys.Add
                ZooomP()
            Case Keys.Subtract
                ZooomM()
            Case Keys.Space
                gmatrix.Reset()
            Case Keys.Delete
                source.nMode = Principal.DELETE
            Case Keys.ControlKey
                ctrlKey = True
            Case Keys.Escape
                deselectAll()
        End Select
        MoveWithKeys(e.KeyCode)
    End Sub

    Public Sub MouseDown(sender As Object, e As MouseEventArgs)
        If (e.Button = MouseButtons.Left) Then
            If (poMenu.isVisible) Then
                Dim op As ptObject = poMenu.DestroyPopupMenu()
                If (op.name IsNot Nothing) Then
                    lstSelDrawOject.Clear()
                    If op.draw = Principal.LABEL Then
                        If op.directionText = "Vertical" Then
                            op.X2.X = op.X1.X + op.font.GetHeight() * 3 / 2
                        Else
                            op.X2.X = op.X1.X + MeasureDisplayStringWidth(op.text, op.font) + 10
                        End If
                    End If
                    lstSelDrawOject.Add(op)
                    Draw()
                End If
            End If
            bMouseDown = True
            If (source.nMode = Principal.ZOOM_M Or source.nMode = Principal.ZOOM_P) Then
                ctrlKey = True
            End If
            HscrollX = source.Design.HorizontalScroll.Value
            VscrollY = source.Design.VerticalScroll.Value
            oldLocation.Y = 0
            oldLocation.X = 0
            lstDrawOject = lstDrawOject.Cast(Of ptObject)().OrderBy(Function(i As ptObject) Convert.ToBoolean(Not i.bringToFront)).ToList()

            If (source.nMode = Principal.SELECTION) Then

                If (lstSelDrawOject.Count = 1) Then

                    Dim p As ptObject = lstSelDrawOject(0)
                    If (e.Location.X + HscrollX) > p.X1.X - (p.rotation * 10) And (e.Location.X + HscrollX) < p.X1.X + 25 - (p.rotation * 10) And
                        ((e.Location.Y + VscrollY) > p.X1.Y + (p.rotation * 10)) And (e.Location.Y + VscrollY < p.X1.Y + 25 + (p.rotation * 10)) And
                        p.draw <> Principal.BULLONE And p.draw <> Principal.ELLIPSE And p.draw <> Principal.LABEL Then
                        If p.rotation < 180 Then
                            p.rotation += 5
                            For Each py In lstDrawOject
                                If py.name = p.name Then
                                    lstDrawOject.Remove(py)
                                    lstSelDrawOject.Clear()
                                    lstDrawOject.Add(p)
                                    lstSelDrawOject.Add(p)
                                    Draw()
                                    Exit Sub
                                End If
                            Next
                        End If
                        Exit Sub
                    End If
                    If (e.Location.X + HscrollX) > p.X2.X - (p.rotation * 10) And (e.Location.X + HscrollX) < p.X2.X + 25 And
                       (e.Location.Y + VscrollY > p.X2.Y - 10 + (p.rotation * 10)) And (e.Location.Y + VscrollY < p.X2.Y + 21 + (p.rotation * 10)) _
                       And p.draw <> Principal.BULLONE And p.draw <> Principal.ELLIPSE And p.draw <> Principal.LABEL Then
                        If p.rotation > 0 Then
                            p.rotation -= 5
                            If p.rotation < 0 Then p.rotation = 0
                            For Each py In lstDrawOject
                                If py.name = p.name Then
                                    lstDrawOject.Remove(py)
                                    lstSelDrawOject.Clear()
                                    lstDrawOject.Add(p)
                                    lstSelDrawOject.Add(p)
                                    Draw()
                                    Exit Sub
                                End If
                            Next
                        End If
                        Exit Sub
                    End If

                End If

                For Each pt In lstDrawOject
                    If InRegion(e, pt) Then
                        AddSelectionObject(pt)
                        Draw()
                        Exit Sub
                    End If
                Next
                If (lstSelDrawOject.Count = 0) Then
                    bInSelect = True
                    ptSelAll = New Point(e.Location.X + HscrollX, (e.Location.Y + VscrollY))
                    oldLocation.X = 0
                    For Each pt In lstDrawOject
                        If InRegion(e, pt) Then
                            AddSelectionObject(pt)
                        End If
                    Next
                    Draw()
                Else
                    bInSelect = False
                End If
                Exit Sub
            End If
            ptObjectC = New ptObject
            ptObjectC.X1.X = e.Location.X + HscrollX
            ptObjectC.X1.Y = (e.Location.Y + VscrollY)
            ptObjectC.name = "obj" & lstDrawOject.Count + 1
            ptObjectC.orderDesign = lstDrawOject.Count + 1
            ptObjectC.dCube = 0
            If source.nMode = Principal.CUBO Then
                ptObjectC.dCube = 50
            End If


            If source.nMode = Principal.LABEL Then
                If Not editText.Visible Then
                    editText.Location = New Point(e.Location.X + HscrollX, (e.Location.Y + VscrollY))
                    editText.Visible = True
                    editText.ForeColor = source._designSettings.DesignForeColor
                    editText.BackColor = source._designSettings.DesignBackColor
                    editText.Font = New Font(source._designSettings.DesignFont.Name, source._designSettings.DesignFont.Size)
                    ptObjectC.directionText = source._designSettings.DesignDirectionText
                    editText.Select()
                    Exit Sub
                Else
                    editTextLeave(sender, e)
                    Exit Sub
                End If
            End If
            If (source.nMode = Principal.FILL) Then
                ptFill.X = e.Location.X + HscrollX
                ptFill.Y = (e.Location.Y + VscrollY)
            End If
            If (source.nMode = Principal.CURVE) Then
                Dim pt As New PointF(e.Location.X + HscrollX, (e.Location.Y + VscrollY))
                lstCurveDrawOject.Add(pt)
            End If
            Draw()
        Else
            FinalizeCurveDraw()
        End If
    End Sub
    Public Sub FinalizeCurveDraw()
        If (source.nMode = Principal.CURVE And Not bFinalizeDrawCurve) Then
            Dim obj As New ptObject
            obj.name = "obj" & lstDrawOject.Count + 1
            obj.orderDesign = lstDrawOject.Count + 1
            obj.lstPtCurve = New ArrayList
            For Each p In lstCurveDrawOject
                If Not (p.X = 0 Or p.Y = 0) Then
                    obj.lstPtCurve.Add(p)
                End If
            Next
            obj.penLine = New Pen(source._designSettings.DesignForeColor, 1)
            obj.penSize = 1
            obj.bringToFront = True
            obj.ForeColor = source._designSettings.DesignForeColor
            obj.FillColor = source._designSettings.DesignFillColor
            obj.FillColor2 = source._designSettings.DesignFillColor2
            obj.penStyle = Principal.SOLID_STYLE
            obj.draw = Principal.CURVE
            obj.brushBitmap = source._designSettings.DesignBitmap
            calcolaMinMaxCurve(obj)
            lstDrawOject.Add(obj)
            lstCurveDrawOject.Clear()
            Draw()
            bFinalizeDrawCurve = True
        End If
    End Sub
    Public Sub MouseMove(sender As Object, e As MouseEventArgs)

        HscrollX = source.Design.HorizontalScroll.Value
        VscrollY = source.Design.VerticalScroll.Value
        CurrentMouseX = e.Location.X + HscrollX
        CurrentMouseY = e.Location.Y + VscrollY
        If (editText.Visible) Then Exit Sub
        If Principal.SELECTION Then
            If bMouseDown And ptSelAll <> Nothing And bInSelect Then
                ptSelAllF = New Point(e.Location.X + HscrollX, (e.Location.Y + VscrollY))
                For Each pt In lstDrawOject
                    If pt.draw = Principal.CURVE Then
                        calcolaMinMaxCurve(pt)
                        If (ptSelAll.X < pt.X1.X And ptSelAllF.X > pt.X2.X) And (ptSelAll.Y < pt.X1.Y And ptSelAllF.Y > pt.X2.Y) Then
                            AddSelectionObject(pt)
                        End If
                    Else
                        If (pt.X1.X > ptSelAll.X And pt.X1.Y > ptSelAll.Y And
                           pt.X2.X < ptSelAllF.X And pt.X2.Y < ptSelAllF.Y) Then
                            AddSelectionObject(pt)
                        End If
                    End If
                Next
                Draw()
                Exit Sub
            Else
                If lstSelDrawOject.Count = 1 And source.nMode = Principal.SELECTION And Not bMouseDown Then
                    source.ResetResize()
                    Dim o As ptObject = lstSelDrawOject(0)
                    calcolaMinMaxCurve(o)
                    If ((e.Location.X + HscrollX) > o.X2.X - 10) And ((e.Location.X + HscrollX) < o.X2.X) And
                        (((e.Location.Y + VscrollY)) > o.X1.Y - 10 + (o.rotation * 10)) And (((e.Location.Y + VscrollY)) < o.X1.Y + 10 + (o.rotation * 10)) Then
                        source.Cursor = Cursors.Hand
                        If (Not poMenu.isVisible) Then
                            poMenu.GetPopupMenuStyleLines(o, source.Design, o.X2.X - HscrollX, o.X1.Y - VscrollY + (o.rotation * 10), source._objSettings)
                        End If
                        Exit Sub
                    End If
                    If (o.draw <> Principal.LABEL) Then
                        If ((e.Location.X + HscrollX) > ((o.X1.X - (o.rotation * 10)) + ((o.X2.X - (o.X1.X - (o.rotation * 10))) / 2)) And
                            ((e.Location.X + HscrollX) < ((o.X1.X - (o.rotation * 10)) + ((o.X2.X - (o.X1.X - (o.rotation * 10))) / 2) + 10) And
                          (((e.Location.Y + VscrollY)) > o.X1.Y - 10 + (o.rotation * 10)) And (((e.Location.Y + VscrollY)) < o.X1.Y + 10 + (o.rotation * 10)))) Then
                            source.Cursor = Cursors.SizeNS
                            source.nResizeUp = True
                            objResize = o
                            Exit Sub
                        End If
                        If ((e.Location.X + HscrollX) > ((o.X1.X - (o.rotation * 10)) + ((o.X2.X - (o.X1.X - (o.rotation * 10))) / 2)) And
                            ((e.Location.X + HscrollX) < ((o.X1.X - (o.rotation * 10)) + ((o.X2.X - (o.X1.X - (o.rotation * 10))) / 2) + 10) And
                         (((e.Location.Y + VscrollY)) > o.X2.Y - 10 + (o.rotation * 10)) And (((e.Location.Y + VscrollY)) < o.X2.Y + 10 + (o.rotation * 10)))) Then
                            source.Cursor = Cursors.SizeNS
                            source.nResizeDown = True
                            objResize = o
                            Exit Sub
                        End If
                        If ((e.Location.X + HscrollX) > o.X1.X - 5 - (o.rotation * 10) And ((e.Location.X + HscrollX) < o.X1.X + 10 - (o.rotation * 10)) And
                            (((e.Location.Y + VscrollY)) > o.X1.Y + ((o.X2.Y - o.X1.Y) / 2)) + (o.rotation * 10) And (((e.Location.Y + VscrollY)) < o.X1.Y + ((o.X2.Y - o.X1.Y) / 2)) + 10 + (o.rotation * 10)) Then
                            source.Cursor = Cursors.SizeWE
                            source.nResizeLeft = True
                            objResize = o
                            Exit Sub
                        End If
                        If ((e.Location.X + HscrollX) > o.X2.X And ((e.Location.X + HscrollX) < o.X2.X + 10) And
                            (((e.Location.Y + VscrollY)) > o.X1.Y + ((o.X2.Y - o.X1.Y) / 2)) + (o.rotation * 10) And
                            (((e.Location.Y + VscrollY)) < o.X1.Y + ((o.X2.Y - o.X1.Y) / 2)) + 10 + (o.rotation * 10)) Then
                            source.Cursor = Cursors.SizeWE
                            source.nResizeRight = True
                            objResize = o
                            Exit Sub
                        End If
                    End If
                End If
            End If
        End If
        If source.nMode = Principal.FILL And source.Cursor <> cursorFill Then
            source.Cursor = cursorFill
        End If
        If bMouseDown Then
            If source.IsInResize And Not objResize.name Is Nothing Then
                If (source.nResizeLeft) Then
                    objResize.X1.X = e.Location.X + HscrollX
                    UpdateLstCurveXLeft(objResize)
                End If
                If (source.nResizeRight) Then
                    objResize.X2.X = e.Location.X + HscrollX
                    'UpdateLstCurveXRight(objResize)
                End If
                If (source.nResizeUp) Then
                    objResize.X1.Y = (e.Location.Y + VscrollY)
                    'UpdateLstCurveYUp(objResize)
                End If
                If (source.nResizeDown) Then
                    objResize.X2.Y = (e.Location.Y + VscrollY)
                    'UpdateLstCurveYDown(objResize)
                End If
                For Each pt In lstDrawOject
                    If (pt.name = objResize.name) Then
                        lstDrawOject.Remove(pt)
                        Exit For
                    End If
                Next
                If (Not objResize.name Is Nothing) Then
                    lstSelDrawOject.Clear()
                    lstSelDrawOject.Add(objResize)
                    lstTempDrawOject.Add(objResize)
                End If
                Draw()
                Exit Sub
            End If
            diffX = 0
            If (oldLocation.X <> 0) Then
                diffX = (e.Location.X + HscrollX) - oldLocation.X
            End If
            diffY = 0
            If (oldLocation.Y <> 0) Then
                diffY = ((e.Location.Y + VscrollY)) - oldLocation.Y
            End If
            oldLocation.Y = (e.Location.Y + VscrollY)
            oldLocation.X = e.Location.X + HscrollX
            If source.nMode = Principal.SELECTION Then
                source.Cursor = Cursors.SizeAll
                UpdateDesign(New Point(e.Location.X + HscrollX, (e.Location.Y + VscrollY)))
            End If

            If source.nMode = Principal.PEN Then
                ptObjectC = New ptObject
                source.Cursor = New Cursor("Pen.cur")
                ptObjectC.name = "obj" & lstDrawOject.Count + 1
                ptObjectC.orderDesign = lstDrawOject.Count + 1
                ptObjectC.X1.X = e.Location.X + HscrollX
                ptObjectC.X1.Y = (e.Location.Y + VscrollY)
                ptObjectC.X2.X = e.Location.X + HscrollX
                ptObjectC.X2.Y = (e.Location.Y + VscrollY)
                ptObjectC.penLine = New Pen(source._designSettings.DesignForeColor, 1)
                ptObjectC.penSize = 1
                ptObjectC.bringToFront = True
                ptObjectC.ForeColor = source._designSettings.DesignForeColor
                ptObjectC.FillColor = source._designSettings.DesignFillColor
                ptObjectC.FillColor2 = source._designSettings.DesignFillColor2
                ptObjectC.penStyle = Principal.SOLID_STYLE
                ptObjectC.draw = source.nMode
                lstDrawOject.Add(ptObjectC)
            Else
                If (source.nMode > 0 And source.nMode < source.NUMGRAPHICS) And Not ptObjectC.name Is Nothing Then
                    source.Cursor = New Cursor("Pen.cur")
                    ptObjectC.X2.X = e.Location.X + HscrollX
                    ptObjectC.X2.Y = (e.Location.Y + VscrollY)
                    ptObjectC.penLine = New Pen(source._designSettings.DesignForeColor, 1)
                    ptObjectC.penSize = 1
                    ptObjectC.bringToFront = True
                    ptObjectC.ForeColor = source._designSettings.DesignForeColor
                    ptObjectC.FillColor = source._designSettings.DesignFillColor
                    ptObjectC.FillColor2 = source._designSettings.DesignFillColor2
                    ptObjectC.penStyle = Principal.SOLID_STYLE
                    ptObjectC.brushBitmap = source._designSettings.DesignBitmap
                    ptObjectC.draw = source.nMode
                    lstTempDrawOject.Add(ptObjectC)
                End If
            End If
            Draw()
        End If
    End Sub



    Private Sub UpdateLstCurveXLeft(ByRef obj As ptObject)
        If obj.draw <> Principal.CURVE Then Exit Sub
        Dim lst As New ArrayList

        For i = 0 To obj.lstPtCurve.Count - 1
            Dim o As New PointF
            o = obj.lstPtCurve(i)
            If Abs(obj.X1.X - o.X) < 5 Then
                If (obj.X1.X > o.X + 5) Then
                    o.X = o.X + Abs(obj.X1.X - o.X)
                End If
                If (obj.X1.X < o.X + 5) Then
                    o.X = o.X - Abs(obj.X1.X - o.X)
                End If
            End If
            lst.Add(o)
        Next
        obj.lstPtCurve.Clear()
        For Each o In lst
            obj.lstPtCurve.Add(o)
        Next
    End Sub
    Private Sub UpdateLstCurveXRight(ByRef obj As ptObject)
        If obj.draw <> Principal.CURVE Then Exit Sub
        Dim lst As New ArrayList

        For i = 0 To obj.lstPtCurve.Count - 1
            Dim o As New PointF
            o = obj.lstPtCurve(i)
            o.X = o.X
            lst.Add(o)
        Next
        obj.lstPtCurve.Clear()
        For Each o In lst
            obj.lstPtCurve.Add(o)
        Next
    End Sub
    Private Sub UpdateLstCurveYUp(ByRef obj As ptObject)
        If obj.draw <> Principal.CURVE Then Exit Sub
        Dim lst As New ArrayList
        For i = 0 To obj.lstPtCurve.Count - 1
            Dim o As New PointF
            o = obj.lstPtCurve(i)
            o.Y = o.Y
            lst.Add(o)
        Next
        obj.lstPtCurve.Clear()
        For Each o In lst
            obj.lstPtCurve.Add(o)
        Next
    End Sub
    Private Sub UpdateLstCurveYDown(ByRef obj As ptObject)
        If obj.draw <> Principal.CURVE Then Exit Sub
        Dim lst As New ArrayList
        For i = 0 To obj.lstPtCurve.Count - 1
            Dim o As New PointF
            o = obj.lstPtCurve(i)
            o.Y = o.Y
            lst.Add(o)
        Next
        obj.lstPtCurve.Clear()
        For Each o In lst
            obj.lstPtCurve.Add(o)
        Next
    End Sub
    Private Sub Resize(sender As Object, e As EventArgs)
        Draw()
    End Sub

    Public Sub deselectAll()
        lstSelDrawOject.Clear()
        Draw()
    End Sub

    Private Sub editTextKeydown(sender As Object, e As KeyEventArgs)
        If e.KeyCode <> Keys.Enter Then Exit Sub
        If editText.Visible = True Then
            editTextLeave(sender, e)
            Exit Sub
        End If
    End Sub
    Private Sub editTextLeave(sender As Object, e As EventArgs)
        If Trim(editText.Text) <> "" Then
            ptObjectC.name = "obj" & lstDrawOject.Count + 1
            ptObjectC.orderDesign = lstDrawOject.Count + 1
            ptObjectC.text = editText.Text
            ptObjectC.text.Trim()
            ptObjectC.draw = Principal.LABEL
            ptObjectC.ForeColor = source._designSettings.DesignForeColor
            editText.Text = ""
            ptObjectC.font = New Font(source._designSettings.DesignFont.Name, source._designSettings.DesignFont.Size)
            ptObjectC.bringToFront = True
            ptObjectC.brushBitmap = source._designSettings.DesignBitmap
            ptObjectC.penStyle = Principal.SOLID_STYLE
            ptObjectC.FillColor = source._designSettings.DesignFillColor
            ptObjectC.FillColor2 = source._designSettings.DesignFillColor2
            If ptObjectC.directionText = "Vertical" Then
                ptObjectC.X2.X = ptObjectC.X1.X + ptObjectC.font.GetHeight() * 3 / 2
            Else
                ptObjectC.X2.X = ptObjectC.X1.X + ptObjectC.font.Size * Len(ptObjectC.text) + 10
            End If
            lstDrawOject.Add(ptObjectC)
            editText.Visible = False
            source.Design.Select()
        Else
            editText.Visible = False
        End If
    End Sub

    Public Sub MouseUp(sender As Object, e As MouseEventArgs)
        source.Cursor = Nothing
        ptSelAll = Nothing
        ptSelAllF = Nothing
        ctrlKey = False
        HscrollX = source.Design.HorizontalScroll.Value
        VscrollY = source.Design.VerticalScroll.Value
        If (source.nMode <> Principal.FILL) Then
            source.Cursor = Cursors.Default
        End If
        bMouseDown = False
        If (source.nMode > 0 And source.nMode < source.NUMGRAPHICS) And Not source.IsInResize And source.nMode <> Principal.CURVE And source.nMode <> Principal.PEN Then
            ptObjectC.X2.X = e.Location.X + HscrollX
            ptObjectC.X2.Y = (e.Location.Y + VscrollY)
            ptObjectC.brushBitmap = ""
            ptObjectC.XORIG1.X = ptObjectC.X1.X
            ptObjectC.XORIG2.X = ptObjectC.X2.X
            ptObjectC.XORIG1.Y = ptObjectC.X1.Y
            ptObjectC.XORIG2.Y = ptObjectC.X2.Y
            ptObjectC.rotation = 0
            ptObjectC.penLine = New Pen(source._designSettings.DesignForeColor, 1)
            ptObjectC.brushBitmap = source._designSettings.DesignBitmap
            ptObjectC.penStyle = Principal.SOLID_STYLE
            ptObjectC.penSize = 1
            ptObjectC.dCube = 0
            If source.nMode = Principal.CUBO Then
                ptObjectC.dCube = 50
            End If
            ptObjectC.draw = source.nMode
            ptObjectC.brightness = 1.2F
            ptObjectC.contrast = 1.0F
            ptObjectC.gamma = 1.0F
            ptObjectC.bitmap = source.imageBitmap
            ptObjectC.bringToFront = True
            ptObjectC.name = "obj" & lstDrawOject.Count + 1
            ptObjectC.orderDesign = lstDrawOject.Count + 1
            lstDrawOject.Add(ptObjectC)
            ptObjectC = Nothing
        Else
            If source.IsInResize Then
                For Each ptO In lstDrawOject
                    If (ptO.name = objResize.name) Then
                        lstDrawOject.Remove(ptO)
                        Exit For
                    End If
                Next
                If (Not objResize.name Is Nothing) Then
                    lstDrawOject.Add(objResize)
                End If
                objResize.name = Nothing
            End If
        End If
        Draw()
    End Sub

    Public Sub SalvaProgetto()
        Dim fd As SaveFileDialog = New SaveFileDialog()
        Dim strFileName As String = ""
        fd.Title = "Salva progetto"
        fd.InitialDirectory = "c:"
        fd.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*"
        fd.FilterIndex = 2
        fd.RestoreDirectory = True
        If fd.ShowDialog() = DialogResult.OK Then
            strFileName = fd.FileName
        End If
        If Trim(strFileName) = "" Then
            Exit Sub
        End If
        Dim i As Integer
        Dim strPath As String
        i = InStr(1, strFileName, ".", CompareMethod.Text)
        If i <= 0 Then
            strFileName = strFileName & ".xml"
        End If
        Dim xws As XmlWriterSettings = New XmlWriterSettings()
        xws.Indent = True
        xws.NewLineOnAttributes = True

        strPath = Path.GetDirectoryName(strFileName)
        Dim xw As XmlWriter = XmlWriter.Create(strFileName, xws)
        xw.WriteStartDocument()
        xw.WriteStartElement("Project")
        i = 1
        For Each ptO In lstDrawOject
            If ptO.penLine Is Nothing Then
                ptO.penLine = New Pen(Color.Black)
            End If
            xw.WriteElementString("name", ptO.name)
            xw.WriteElementString("draw", ptO.draw)
            xw.WriteElementString("X1X", ptO.X1.X)
            xw.WriteElementString("X1Y", ptO.X1.Y)
            xw.WriteElementString("X2X", ptO.X2.X)
            xw.WriteElementString("X2Y", ptO.X2.Y)
            If (Not ptO.bitmap Is Nothing) Then
                ptO.bitmap.Save(strPath & "\objBitmap" & CStr(i) & ".bmp", System.Drawing.Imaging.ImageFormat.Bmp)
                xw.WriteElementString("Bitmap", strPath & "\objBitmap" & CStr(i) & ".bmp")
                i = i + 1
            Else
                xw.WriteElementString("Bitmap", "")
            End If
            xw.WriteElementString("PenLineColor", ptO.penLine.Color.ToString())
        Next
        xw.WriteEndElement()
        xw.WriteEndDocument()
        xw.Flush()
        xw.Close()
    End Sub

    Public Sub LoadProject()
        Dim fd As OpenFileDialog = New OpenFileDialog()
        Dim strFileName As String = ""
        fd.Title = "Apri progetto"
        fd.InitialDirectory = "c:"
        fd.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*"
        fd.FilterIndex = 2
        fd.RestoreDirectory = True
        If fd.ShowDialog() = DialogResult.OK Then
            strFileName = fd.FileName
        End If
        If strFileName = "" Then
            Exit Sub
        End If
        Dim xr As XmlReader = XmlReader.Create(strFileName)
        Dim obj As New ptObject
        Dim x1x As Integer = 0
        Dim x1y As Integer = 0
        Dim x2x As Integer = 0
        Dim x2y As Integer = 0
        Do While xr.Read()
            Dim read As Boolean = False
            If (xr.NodeType = XmlNodeType.Element) Then

                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "name" Then
                    obj.name = xr.ReadElementString()
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "draw" Then
                    obj.draw = CInt(xr.ReadElementString())
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "X1X" Then
                    x1x = CInt(xr.ReadElementString())
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "X1Y" Then
                    x1y = CInt(xr.ReadElementString())
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "X2X" Then
                    x2x = CInt(xr.ReadElementString())
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "X2Y" Then
                    x2y = CInt(xr.ReadElementString())
                    obj.X1 = New Point(x1x, x1y)
                    obj.X2 = New Point(x2x, x2y)
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "Bitmap" Then
                    Dim s As String = xr.ReadElementString()
                    If (s <> "") Then
                        obj.bitmap = New Bitmap(s)
                    End If
                    read = True
                End If
                If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "PenLineColor" Then
                    Dim s() As String
                    Dim s1 As Integer
                    Dim s2 As Integer
                    Dim s3 As Integer
                    Dim s4 As Integer
                    Dim svalue = xr.ReadElementString()
                    Dim i As Integer = InStr(1, svalue, "=", CompareMethod.Text)
                    If i > 0 Then
                        svalue = svalue.Replace("]", "")
                        svalue = svalue.Replace("[", "")
                        s = svalue.Split(",")
                        s1 = CInt(s(0).Substring(s(0).IndexOf("=") + 1))
                        s2 = CInt(s(1).Substring(s(1).IndexOf("=") + 1))
                        s3 = CInt(s(2).Substring(s(2).IndexOf("=") + 1))
                        s4 = CInt(s(3).Substring(s(3).IndexOf("=") + 1))
                        obj.penLine = New Pen(Color.FromArgb(s1, s2, s3, s4))
                    End If
                    lstDrawOject.Add(obj)
                    obj = Nothing
                    obj = New ptObject
                    read = True
                End If
                If (Not read) Then
                    xr.Read()
                End If
            Else
                xr.Read()
            End If
        Loop
        xr.Close()
        Draw()
    End Sub

    Private Sub MouseClick(sender As Object, e As MouseEventArgs)
        source.dmenu.MenuLeave()
    End Sub


    Public Sub CopySelectedObject()
        lstCopiedSelDrawOject.Clear()
        For Each p In lstSelDrawOject
            lstCopiedSelDrawOject.Add(p)
        Next
    End Sub
    Public Sub PasteCopiedObject()
        lstSelDrawOject.Clear()
        For Each p In lstCopiedSelDrawOject
            Dim pn As New ptObject
            pn = p
            pn.name = "obj" & CStr(lstDrawOject.Count + 1)
            pn.X1.X = pn.X1.X - 50
            pn.X2.X = pn.X2.X - 50
            lstSelDrawOject.Add(pn)
            lstDrawOject.Add(pn)
        Next
        lstCopiedSelDrawOject.Clear()
        source.setButtonSelectiobSelected()
        source.nMode = Principal.SELECTION
        Draw()

    End Sub



    Public Sub Update()
        If source.bIncolla And source.bCopy Then
            Dim maxPos As Integer
            Dim minPos As Integer
            Dim wPos As Integer
            maxPos = 0
            minPos = 0
            Dim ptObjectCopied As ptObject
            For Each pt In lstSelDrawOject
                If maxPos < pt.X2.X Then
                    maxPos = pt.X2.X
                End If
                If minPos > pt.X1.X Or minPos = 0 Then
                    minPos = pt.X1.X
                End If
            Next
            wPos = maxPos - minPos
            For Each pt In lstSelDrawOject
                ptObjectCopied = New ptObject()
                ptObjectCopied = pt
                ptObjectCopied.name = "obj" & lstDrawOject.Count + 1
                ptObjectCopied.orderDesign = lstDrawOject.Count + 1
                ptObjectCopied.X1.X = pt.X1.X - wPos
                ptObjectCopied.X2.X = pt.X2.X - wPos
                lstDrawOject.Add(ptObjectCopied)
                source.bIncolla = False
            Next
            Draw()
        End If
        If Not source.IsInResize Then
            objResize = Nothing
        End If
        Select Case source.nMode
            Case Principal.CLEAR
                lstDrawOject.Clear()
                lstTempDrawOject.Clear()
                lstCurveDrawOject.Clear()
                source.imageBitmap = Nothing
                Draw()
                source.nMode = -1
                Exit Sub
            Case Principal.IIMAGE
                If Not source.imageBitmap Is Nothing Then
                    ptObjectC.name = "obj" & lstDrawOject.Count + 1
                    ptObjectC.orderDesign = lstDrawOject.Count + 1
                    ptObjectC.X1 = New Point(0, 0)
                    ptObjectC.bitmap = source.imageBitmap
                    ptObjectC.X2 = New Point(ptObjectC.X1.X + ptObjectC.bitmap.Size.Width, ptObjectC.X1.Y + ptObjectC.bitmap.Size.Height)
                    ptObjectC.draw = source.nMode
                    ptObjectC.contrast = 1.0F
                    ptObjectC.gamma = 1.0F
                    ptObjectC.brightness = 1.2F
                    source.nMode = -1
                    lstDrawOject.Add(ptObjectC)
                    Draw()
                End If
        End Select

    End Sub

    Public Sub UpdateDesign(loc As Point)
        lstSelUpdDrawOject.Clear()
        If (oldLocation.Y <> loc.Y Or
            oldLocation.X <> loc.X) Then
            Exit Sub
        End If
        For Each pt In lstSelDrawOject
            movePtinSelection(pt)
        Next pt
        lstSelDrawOject.Clear()
        For Each pt In lstSelUpdDrawOject
            AddSelectionObject(pt)
        Next
    End Sub

    Private Function CalcolaNewPointInMoveSelection(pt As ptObject)
        Dim newPt As ptObject
        If (pt.lstPtCurve Is Nothing) Then
            newPt = pt
            If (diffX > 0) Then
                newPt.X1.X += Math.Abs(diffX)
                newPt.X2.X += Math.Abs(diffX)
            ElseIf diffX < 0 Then
                newPt.X1.X -= Math.Abs(diffX)
                newPt.X2.X -= Math.Abs(diffX)
            End If
            If (diffY > 0) Then
                newPt.X1.Y += Math.Abs(diffY)
                newPt.X2.Y += Math.Abs(diffY)
            ElseIf diffY < 0 Then
                newPt.X1.Y -= Math.Abs(diffY)
                newPt.X2.Y -= Math.Abs(diffY)
            End If
            newPt.XORIG1.X = newPt.X1.X
            newPt.XORIG2.X = newPt.X2.X
            newPt.XORIG1.Y = newPt.X1.Y
            newPt.XORIG2.Y = newPt.X2.Y
            Return newPt
        Else
            newPt = New ptObject
            newPt.draw = pt.draw
            newPt.penLine = pt.penLine
            newPt.name = pt.name
            newPt.FillColor = pt.FillColor
            newPt.FillColor2 = pt.FillColor2
            newPt.ForeColor = pt.ForeColor
            newPt.brushBitmap = pt.brushBitmap
            newPt.penSize = pt.penSize
            newPt.penStyle = pt.penStyle
            newPt.penLine = pt.penLine
            newPt.draw = pt.draw
            newPt.lstPtCurve = New ArrayList
            For Each o In pt.lstPtCurve
                If (diffX > 0) Then
                    o.X += Math.Abs(diffX)
                ElseIf diffX < 0 Then
                    o.X -= Math.Abs(diffX)
                End If
                If (diffY > 0) Then
                    o.Y += Math.Abs(diffY)
                ElseIf diffY < 0 Then
                    o.Y -= Math.Abs(diffY)
                End If
                newPt.lstPtCurve.Add(o)
            Next
            Return newPt
        End If
    End Function
    Private Sub movePtinSelection(pt As ptObject)
        Dim newPt As ptObject = CalcolaNewPointInMoveSelection(pt)
        For Each ptO In lstDrawOject
            If (ptO.name = pt.name And Not ptO.name Is Nothing) Then
                lstDrawOject.Remove(ptO)
                lstDrawOject.Add(newPt)
                Exit For
            End If
        Next
        Dim b As Boolean = False
        For Each pta In lstSelUpdDrawOject
            If newPt.name = pta.name Then
                b = True
                Exit For
            End If
        Next
        If Not b Then
            lstSelUpdDrawOject.Add(newPt)
        End If
    End Sub

    Public Sub AddSelectionObject(obj As ptObject)
        Dim b As Boolean = False
        For Each o In lstSelDrawOject
            If o.name = obj.name Then
                b = True
                Exit For
            End If
        Next
        If (Not b) Then
            lstSelDrawOject.Add(obj)
        End If
    End Sub

    Public Sub calcolaMinMaxCurve(ByRef pt As ptObject)
        If pt.lstPtCurve Is Nothing Then Exit Sub
        Dim minX As Integer = 0
        Dim minY As Integer = 0
        Dim maxX As Integer = 0
        Dim maxY As Integer = 0
        For Each o In pt.lstPtCurve
            If minX = 0 Then
                minX = o.X
            Else
                If (minX > o.X) Then
                    minX = o.X
                End If
            End If
            If minY = 0 Then
                minY = o.Y
            Else
                If (minY > o.Y) Then
                    minY = o.Y
                End If
            End If
            If maxX = 0 Then
                maxX = o.X
            Else
                If (maxX < o.X) Then
                    maxX = o.X
                End If
            End If
            If maxY = 0 Then
                maxY = o.Y
            Else
                If (maxY < o.Y) Then
                    maxY = o.Y
                End If
            End If
        Next
        pt.X1.X = minX
        pt.X2.X = maxX
        pt.X1.Y = minY
        pt.X2.Y = maxY
    End Sub

    Function getBitmap() As Bitmap
        Return bm
        Throw New NotImplementedException
    End Function

End Class