﻿Imports System.IO
Imports System.Text

Public Class CreatePDF
    Private out As System.IO.FileStream
    Private Sub WriStr(s As String)
        out.Write(System.Text.Encoding.ASCII.GetBytes(s), 0, s.Length)
    End Sub
    Public Function CreatePdf(bmp As Bitmap)
        On Error Resume Next
        Dim strPath As String = FileSystem.CurDir
        Dim sDir As String = FileSystem.Dir(FileSystem.CurDir & "\Pdf", FileAttribute.Directory)
        If sDir = "" Then
            FileSystem.MkDir(FileSystem.CurDir & "\Pdf")
        End If
        sDir = FileSystem.CurDir & "\Pdf"
        Dim OutPdf As String = sDir + "\OutFile" & CStr(Date.Now.Hour) & CStr(Date.Now.Minute) & CStr(Date.Now.Second) & ".pdf"
        Dim strFileName As String = sDir + "\OutIma" & CStr(Date.Now.Hour) & CStr(Date.Now.Minute) & CStr(Date.Now.Second) & ".jpeg"
        Dim w As Integer = bmp.Width
        Dim h As Integer = bmp.Height
        Dim wf As String = CStr(w * 72) / bmp.HorizontalResolution
        Dim hf As String = CStr(h * 72) / bmp.VerticalResolution
        For Each deleteFile In Directory.GetFiles(sDir, "*.jpeg", SearchOption.TopDirectoryOnly)
            File.Delete(deleteFile)
        Next
        For Each deleteFile In Directory.GetFiles(sDir, "*.pdf", SearchOption.TopDirectoryOnly)
            File.Delete(deleteFile)
        Next
        File.Delete(OutPdf)
        bmp.Save(strFileName, System.Drawing.Imaging.ImageFormat.Jpeg)
        wf = wf.Replace(",", ".")
        hf = hf.Replace(",", ".")
        out = File.Create(OutPdf)
        Dim lens As New ArrayList()
        WriStr("%PDF-1.5" + vbCrLf)
        lens.Add(out.Position)
        WriStr(CStr(lens.Count) + " 0 obj " + "<</Type /Catalog" + vbCrLf + "/Pages 2 0 R>>" + vbCrLf + "endobj" + vbCrLf)
        lens.Add(out.Position)
        WriStr(CStr(lens.Count) + " 0 obj " + "<</Count 1/Kids [ <<" + vbCrLf + "" +
                     "/Type /Page" + vbCrLf + "" +
                     "/Rotate 1" + vbCrLf + "" +
                     "/Parent 2 0 R" + vbCrLf + "" +
                     "/MediaBox [0 0 " + wf + " " + hf + "]" + vbCrLf + "" +
                     "/Resources<<  /ProcSet [/PDF /ImageC]" + vbCrLf + " /XObject <</Im1 4 0 R >>  >>" + vbCrLf + "" +
                     "/Contents 3 0 R" + vbCrLf + "" +
                     ">>" + vbCrLf + " ]" + vbCrLf + "" +
                     ">>" + vbCrLf + "endobj" + vbCrLf + "")

        Dim X As String = "" + vbCrLf + "" +
                "q" + vbCrLf + "" +
                "" + wf + " 0 0 " + hf + " 0 0 cm" + vbCrLf + "" +
                "/Im1 Do" + vbCrLf + "" +
                "Q" + vbCrLf + ""
        lens.Add(out.Position)

        WriStr(CStr(lens.Count) + " 0 obj " + "<</Length " + CStr(X.Length) + ">>" +
                        "stream" + X + "endstream" + vbCrLf + "" +
                        "endobj" + vbCrLf + "")
        lens.Add(out.Position)

        WriStr(CStr(lens.Count) + " 0 obj " + "<</Name /Im1" +
                        "/Type /XObject" + vbCrLf + "" +
                        "/Subtype /Image" + vbCrLf + "" +
                        "/Width " + w.ToString() +
                        "/Height " + h.ToString() +
                        "/Length 5 0 R" + vbCrLf + "" +
                        "/Filter /DCTDecode" + vbCrLf + "" +
                        "/ColorSpace /DeviceRGB" + vbCrLf + "" +
                        "/BitsPerComponent 8" + vbCrLf + "" +
                        ">> stream" + vbCrLf + "")

        Dim Siz As Long = out.Position
        Dim bufferSize As Integer = 1024
        Dim inputFile = IO.File.Open(strFileName, IO.FileMode.Open)
        Dim bytes = New Byte(bufferSize - 1) {}

        While inputFile.Read(bytes, 0, bufferSize) > 0
            out.Write(bytes, 0, bufferSize)
        End While
        Siz = out.Position - Siz

        WriStr("" + vbCrLf + "endstream" + vbCrLf + "" + "endobj" + vbCrLf + "")
        lens.Add(out.Position)
        WriStr(CStr(lens.Count) + " 0 obj " + Siz.ToString() + " endobj" + vbCrLf + "")
        Dim startxref As Long = out.Position
        WriStr("xref" + vbCrLf + "" + "0 " + (lens.Count + 1).ToString() + "" + vbCrLf + "" + "0000000000 65535 f" + vbCrLf + "")
        For Each L In lens
            WriStr((10000000000 + L).ToString().Substring(1) + " 00000 n" + vbCrLf + "")
        Next

        WriStr("trailer" + vbCrLf + "" + "<<" + vbCrLf + "" +
                    "  /Size " + (lens.Count + 1).ToString() + "" + vbCrLf + "" +
                    "  /Root 1 0 R" + vbCrLf + "" +
                    ">>" + vbCrLf + "" + "startxref" + vbCrLf + "" + startxref.ToString() + "" + vbCrLf + "%%EOF")
        out.Close()

        Return OutPdf
    End Function

End Class
